--[[
 	This dialog is designed to be used by the plugin author only.  If you use this dialog to creat annotations, they will be overwritten by
	any default annotations that are included in the next update.

	This dialog allows rapid creation of default annotations by selecting the map, annotation type and custom value then when the user clicks
	the "Add" button, the text to create an annotation at the user's coordinates with the text of the users's target will be output to the
	custom chat channel #4.  This chat channel must be set up ahead of time, should be a private password protected channel that will never
	receive any text except from this dialog, and should be logged. The log file from that chat channel can then be used to create new default
	annotations for the defaults.lua file.

	The lock on the Type list only affects the query button.  If the type is locked, the query will fill all available fields but will not try
	to resolve the type. This is handy when processing a lot of undetectable types like NPCs.

]]--
defAnnWindow=Turbine.UI.Lotro.Window();
defAnnWindow:SetText("Default Annotations Maker");
defAnnWindow:SetVisible(false);
defAnnWindow:SetSize(550,600);
defAnnWindow:SetPosition((Turbine.UI.Display:GetWidth() - defAnnWindow:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - defAnnWindow:GetHeight()) / 2);

defAnnWindow.StringIndexCaption=Turbine.UI.Label();
defAnnWindow.StringIndexCaption:SetParent(defAnnWindow);
defAnnWindow.StringIndexCaption:SetPosition(0,40);
defAnnWindow.StringIndexCaption:SetSize(defAnnWindow:GetWidth(),defAnnWindow:GetHeight()-80);
defAnnWindow.StringIndexCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
defAnnWindow.StringIndexCaption:SetForeColor(fontColor);
defAnnWindow.StringIndexCaption:SetText("This dialog and the command that launches it are intended for developer use only and are not functional in the released version.");
defAnnWindow.StringIndexCaption:SetMouseVisible(false);
defAnnWindow.StringIndexText=Turbine.UI.Lotro.TextBox();
defAnnWindow.StringIndexText:SetParent(defAnnWindow.SettingsTab);
defAnnWindow.StringIndexText:SetSize(80,20);
defAnnWindow.StringIndexText:SetPosition(90,defAnnWindow.StringIndexCaption:GetTop());
defAnnWindow.StringIndexText:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
defAnnWindow.StringIndexText:SetText("1");

defAnnWindow.SetTargetInfo=function(Sender,NSCoord,EWCoord,iconType,tier,target)
end
defAnnWindow:SetZOrder(1)
