importPath=string.gsub(getfenv(1)._.Name,"%.IconMaint","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"

iconMaint=Turbine.UI.Lotro.Window()
iconMaint:SetText(Resource[Settings.language][324])
iconMaint:SetSize(400,400)
local displayWidth,displayHeight=Turbine.UI.Display:GetSize()
iconMaint:SetPosition((displayWidth-iconMaint:GetWidth())/2,(displayHeight-iconMaint:GetHeight())/2)
iconMaint:SetZOrder(2)
iconMaint.X=0
iconMaint.Y=0

iconMaint.AnnotTypeCaption=Turbine.UI.Label()
iconMaint.AnnotTypeCaption:SetParent(iconMaint)
iconMaint.AnnotTypeCaption:SetSize(130,20)
iconMaint.AnnotTypeCaption:SetPosition(10,45)
iconMaint.AnnotTypeCaption:SetForeColor(Settings.fontColor)
iconMaint.AnnotTypeCaption:SetText(Resource[Settings.language][325])

iconMaint.AnnotType=DropDownList()
iconMaint.AnnotType:SetParent(iconMaint)
iconMaint.AnnotType:SetPosition(iconMaint.AnnotTypeCaption:GetLeft()+iconMaint.AnnotTypeCaption:GetWidth()+5,iconMaint.AnnotTypeCaption:GetTop())
iconMaint.AnnotType:SetSize(iconMaint:GetWidth()-20-iconMaint.AnnotType:GetLeft(),20)
iconMaint.AnnotType:SetBorderColor(Settings.trimColor);
iconMaint.AnnotType:SetBackColor(Settings.backColor);
iconMaint.AnnotType.CurrentValue:SetBackColor(Settings.backColor);
iconMaint.AnnotType:SetTextColor(Settings.listTextColor);
iconMaint.AnnotType:SetDropRows(10);
iconMaint.AnnotType:SetZOrder(1)
iconMaint.AnnotType.SelectedIndexChanged=function()
	iconMaint.AnnotTypeText:SetText(iconMaint.AnnotType.ListData:GetSelectedItem():GetText())
	local success,result,tmpK,tmpImage
	for k=1,3 do
		tmpK=tostring(k)
		tmpImage=iconInfo[iconMaint.AnnotType:GetValue()][3+k]
		iconMaint["IconText"..tmpK]:SetText(tmpImage)
		if tonumber(tmpImage)==nil then
			success,result=pcall(Turbine.UI.Control.SetBackground,iconMaint["IconImage"..tmpK],resourcePath..tmpImage);
		else
			success,result=pcall(Turbine.UI.Control.SetBackground,iconMaint["IconImage"..tmpK],tonumber(tmpImage));
		end
		if success then
			-- get image x,y
			iconMaint["IconImage"..tmpK]:SetStretchMode(2)
			local x,y=iconMaint["IconImage"..tmpK]:GetSize()
			iconMaint["IconImage"..tmpK]:SetStretchMode(0)
			iconMaint["IconImageSize"..tmpK]:SetText(tostring(x).." x "..tostring(y))
			if x>32 or y>32 then
				iconMaint["IconImageSize"..tmpK]:SetForeColor(Turbine.UI.Color.Red)
				iconMaint["IconImage"..tmpK]:SetPosition(0,0)
			else
				iconMaint["IconImageSize"..tmpK]:SetForeColor(Settings.fontColor)
				iconMaint["IconImage"..tmpK]:SetPosition((32-iconMaint["IconImage"..tmpK]:GetWidth())/2,(32-iconMaint["IconImage"..tmpK]:GetHeight())/2)
			end
			if k==1 then
				iconMaint.X=x
				iconMaint.Y=y
			end
		else
			iconMaint["IconImageSize"..tmpK]:SetForeColor(Turbine.UI.Color.Red)
			iconMaint["IconImageSize"..tmpK]:SetText(Resource[Settings.language][331]..":"..tmpImage)
		end
	end
end

iconMaint.AnnotTypeText=Turbine.UI.Label()
iconMaint.AnnotTypeText:SetParent(iconMaint)
iconMaint.AnnotTypeText:SetSize(iconMaint.AnnotType:GetWidth(),iconMaint.AnnotType:GetHeight())
iconMaint.AnnotTypeText:SetPosition(iconMaint.AnnotType:GetLeft(),iconMaint.AnnotType:GetTop())

iconMaint.Sep1=Turbine.UI.Control()
iconMaint.Sep1:SetParent(iconMaint)
iconMaint.Sep1:SetSize(iconMaint:GetWidth()-20,1)
iconMaint.Sep1:SetPosition(10,iconMaint.AnnotType:GetTop()+iconMaint.AnnotType:GetHeight()+8)
iconMaint.Sep1:SetBackColor(Settings.trimColor)

iconMaint.IconCaption1=Turbine.UI.Label()
iconMaint.IconCaption1:SetParent(iconMaint)
iconMaint.IconCaption1:SetSize(iconMaint.AnnotTypeCaption:GetWidth(),20)
iconMaint.IconCaption1:SetPosition(iconMaint.AnnotTypeCaption:GetLeft(),iconMaint.AnnotTypeCaption:GetTop()+50)
iconMaint.IconCaption1:SetForeColor(Settings.fontColor)
iconMaint.IconCaption1:SetText(Resource[Settings.language][326])
iconMaint.IconCaption1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

iconMaint.IconText1=Turbine.UI.Lotro.TextBox()
iconMaint.IconText1:SetParent(iconMaint)
iconMaint.IconText1:SetPosition(iconMaint.IconCaption1:GetLeft()+iconMaint.IconCaption1:GetWidth()+5,iconMaint.IconCaption1:GetTop())
iconMaint.IconText1:SetSize(iconMaint:GetWidth()-iconMaint.IconCaption1:GetLeft()-iconMaint.IconText1:GetLeft(),20)
iconMaint.IconText1:SetFont(Turbine.UI.Lotro.Font.Verdana16)
iconMaint.IconText1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
iconMaint.IconText1:SetMultiline(false)
iconMaint.IconText1.FocusGained=function(sender,args)
	iconMaint.IconText1:SetWantsKeyEvents(true)
end
iconMaint.IconText1.FocusLost=function(sender,args)
	iconMaint.IconText1:SetWantsKeyEvents(false)
	iconMaint.loadImage(1)
end
iconMaint.IconText1.KeyDown=function(sender,args)
	if args.Action==162 then
		-- enter key
		iconMaint.loadImage(1)
	end	
end

iconMaint.IconBorder1=Turbine.UI.Control()
iconMaint.IconBorder1:SetParent(iconMaint)
iconMaint.IconBorder1:SetSize(34,34)
iconMaint.IconBorder1:SetBackColor(Settings.trimColor)
iconMaint.IconBorder1:SetPosition(25,iconMaint.IconCaption1:GetTop()+20)
iconMaint.IconBack1=Turbine.UI.Control()
iconMaint.IconBack1:SetParent(iconMaint.IconBorder1)
iconMaint.IconBack1:SetSize(32,32)
iconMaint.IconBack1:SetPosition(1,1)
iconMaint.IconBack1:SetBackColor(Turbine.UI.Color.Black)
iconMaint.IconImage1=Turbine.UI.Control()
iconMaint.IconImage1:SetParent(iconMaint.IconBack1)
iconMaint.IconImage1:SetSize(32,32)
iconMaint.IconImage1:SetBlendMode(Turbine.UI.BlendMode.Overlay)

iconMaint.IconImageSize1=Turbine.UI.Label()
iconMaint.IconImageSize1:SetParent(iconMaint)
iconMaint.IconImageSize1:SetSize(100,20)
iconMaint.IconImageSize1:SetPosition(iconMaint.IconBorder1:GetLeft()+40,iconMaint.IconBorder1:GetTop()+7)

iconMaint.IconCaption2=Turbine.UI.Label()
iconMaint.IconCaption2:SetParent(iconMaint)
iconMaint.IconCaption2:SetSize(iconMaint.IconCaption1:GetWidth(),20)
iconMaint.IconCaption2:SetPosition(iconMaint.IconCaption1:GetLeft(),iconMaint.IconCaption1:GetTop()+70)
iconMaint.IconCaption2:SetForeColor(Settings.fontColor)
iconMaint.IconCaption2:SetText(Resource[Settings.language][327])
iconMaint.IconCaption2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

iconMaint.IconText2=Turbine.UI.Lotro.TextBox()
iconMaint.IconText2:SetParent(iconMaint)
iconMaint.IconText2:SetPosition(iconMaint.IconCaption2:GetLeft()+iconMaint.IconCaption2:GetWidth()+5,iconMaint.IconCaption2:GetTop())
iconMaint.IconText2:SetSize(iconMaint:GetWidth()-iconMaint.IconCaption2:GetLeft()-iconMaint.IconText2:GetLeft(),20)
iconMaint.IconText2:SetFont(Turbine.UI.Lotro.Font.Verdana16)
iconMaint.IconText2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
iconMaint.IconText2:SetMultiline(false)
iconMaint.IconText2.FocusGained=function(sender,args)
	iconMaint.IconText2:SetWantsKeyEvents(true)
end
iconMaint.IconText2.FocusLost=function(sender,args)
	iconMaint.IconText2:SetWantsKeyEvents(false)
	iconMaint.loadImage(2)
end
iconMaint.IconText2.KeyDown=function(sender,args)
	if args.Action==162 then
		-- enter key
		iconMaint.loadImage(2)
	end	
end

iconMaint.IconBorder2=Turbine.UI.Control()
iconMaint.IconBorder2:SetParent(iconMaint)
iconMaint.IconBorder2:SetSize(34,34)
iconMaint.IconBorder2:SetBackColor(Settings.trimColor)
iconMaint.IconBorder2:SetPosition(25,iconMaint.IconCaption2:GetTop()+20)
iconMaint.IconBack2=Turbine.UI.Control()
iconMaint.IconBack2:SetParent(iconMaint.IconBorder2)
iconMaint.IconBack2:SetSize(32,32)
iconMaint.IconBack2:SetPosition(1,1)
iconMaint.IconBack2:SetBackColor(Turbine.UI.Color.Black)
iconMaint.IconImage2=Turbine.UI.Control()
iconMaint.IconImage2:SetParent(iconMaint.IconBack2)
iconMaint.IconImage2:SetSize(32,32)
iconMaint.IconImage2:SetBlendMode(Turbine.UI.BlendMode.Overlay)

iconMaint.IconImageSize2=Turbine.UI.Label()
iconMaint.IconImageSize2:SetParent(iconMaint)
iconMaint.IconImageSize2:SetSize(100,20)
iconMaint.IconImageSize2:SetPosition(iconMaint.IconBorder2:GetLeft()+40,iconMaint.IconBorder2:GetTop()+7)

iconMaint.IconCaption3=Turbine.UI.Label()
iconMaint.IconCaption3:SetParent(iconMaint)
iconMaint.IconCaption3:SetSize(iconMaint.IconCaption1:GetWidth(),20)
iconMaint.IconCaption3:SetPosition(iconMaint.IconCaption1:GetLeft(),iconMaint.IconCaption2:GetTop()+70)
iconMaint.IconCaption3:SetForeColor(Settings.fontColor)
iconMaint.IconCaption3:SetText(Resource[Settings.language][328])
iconMaint.IconCaption3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

iconMaint.IconText3=Turbine.UI.Lotro.TextBox()
iconMaint.IconText3:SetParent(iconMaint)
iconMaint.IconText3:SetPosition(iconMaint.IconCaption3:GetLeft()+iconMaint.IconCaption3:GetWidth()+5,iconMaint.IconCaption3:GetTop())
iconMaint.IconText3:SetSize(iconMaint:GetWidth()-iconMaint.IconCaption3:GetLeft()-iconMaint.IconText3:GetLeft(),20)
iconMaint.IconText3:SetFont(Turbine.UI.Lotro.Font.Verdana16)
iconMaint.IconText3:SetMultiline(false)
iconMaint.IconText3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
iconMaint.IconText3.FocusGained=function(sender,args)
	iconMaint.IconText3:SetWantsKeyEvents(true)
end
iconMaint.IconText3.FocusLost=function(sender,args)
	iconMaint.IconText3:SetWantsKeyEvents(false)
	iconMaint.loadImage(3)
end
iconMaint.IconText3.KeyDown=function(sender,args)
	if args.Action==162 then
		-- enter key
		iconMaint.loadImage(3)
	end	
end

iconMaint.IconBorder3=Turbine.UI.Control()
iconMaint.IconBorder3:SetParent(iconMaint)
iconMaint.IconBorder3:SetSize(34,34)
iconMaint.IconBorder3:SetBackColor(Settings.trimColor)
iconMaint.IconBorder3:SetPosition(25,iconMaint.IconCaption3:GetTop()+20)
iconMaint.IconBack3=Turbine.UI.Control()
iconMaint.IconBack3:SetParent(iconMaint.IconBorder3)
iconMaint.IconBack3:SetSize(32,32)
iconMaint.IconBack3:SetPosition(1,1)
iconMaint.IconBack3:SetBackColor(Turbine.UI.Color.Black)
iconMaint.IconImage3=Turbine.UI.Control()
iconMaint.IconImage3:SetParent(iconMaint.IconBack3)
iconMaint.IconImage3:SetSize(32,32)
iconMaint.IconImage3:SetBlendMode(Turbine.UI.BlendMode.Overlay)

iconMaint.IconImageSize3=Turbine.UI.Label()
iconMaint.IconImageSize3:SetParent(iconMaint)
iconMaint.IconImageSize3:SetSize(100,20)
iconMaint.IconImageSize3:SetPosition(iconMaint.IconBorder3:GetLeft()+40,iconMaint.IconBorder3:GetTop()+7)

for k,v in ipairs(iconInfo) do
	iconMaint.AnnotType:AddItem(Resource[Settings.language][v[1]],k)
end

iconMaint.ApplyButton=Turbine.UI.Lotro.Button()
iconMaint.ApplyButton:SetParent(iconMaint)
iconMaint.ApplyButton:SetSize(100,20)
iconMaint.ApplyButton:SetPosition((iconMaint:GetWidth()-iconMaint.ApplyButton:GetWidth()*2)/3,iconMaint:GetHeight()-65)
iconMaint.ApplyButton:SetText(Resource[Settings.language][11])
iconMaint.ApplyButton.Click=function()
	iconMaint.applyChanges()
end

iconMaint.DefaultButton=Turbine.UI.Lotro.Button()
iconMaint.DefaultButton:SetParent(iconMaint)
iconMaint.DefaultButton:SetSize(100,20)
iconMaint.DefaultButton:SetPosition(iconMaint:GetWidth()-iconMaint.ApplyButton:GetLeft()-iconMaint.ApplyButton:GetWidth(),iconMaint:GetHeight()-65)
iconMaint.DefaultButton:SetText(Resource[Settings.language][332])
iconMaint.DefaultButton.Click=function()
	-- restore the default icon values from iconInfo
	local success,result,tmpK,tmpImage
	for k=1,3 do
		tmpK=tostring(k)
		tmpImage=iconInfo[iconMaint.AnnotType:GetValue()][7+k]
		iconInfo[iconMaint.AnnotType:GetValue()][3+k]=tmpImage
		iconMaint["IconText"..tmpK]:SetText(tmpImage)
		if tonumber(tmpImage)==nil then
			success,result=pcall(Turbine.UI.Control.SetBackground,iconMaint["IconImage"..tmpK],resourcePath..tmpImage);
		else
			success,result=pcall(Turbine.UI.Control.SetBackground,iconMaint["IconImage"..tmpK],tonumber(tmpImage));
		end
		if success then
			-- get image x,y
			iconMaint["IconImage"..tmpK]:SetStretchMode(2)
			local x,y=iconMaint["IconImage"..tmpK]:GetSize()
			iconMaint["IconImage"..tmpK]:SetStretchMode(0)
			iconMaint["IconImageSize"..tmpK]:SetText(tostring(x).." x "..tostring(y))
			if x>32 or y>32 then
				iconMaint["IconImageSize"..tmpK]:SetForeColor(Turbine.UI.Color.Red)
				iconMaint["IconImage"..tmpK]:SetPosition(0,0)
			else
				iconMaint["IconImageSize"..tmpK]:SetForeColor(Settings.fontColor)
				iconMaint["IconImage"..tmpK]:SetPosition((32-iconMaint["IconImage"..tmpK]:GetWidth())/2,(32-iconMaint["IconImage"..tmpK]:GetHeight())/2)
			end
			if k==1 then
				iconInfo[iconMaint.AnnotType:GetValue()][2]=x
				iconInfo[iconMaint.AnnotType:GetValue()][3]=y
			end
		else
			iconMaint["IconImageSize"..tmpK]:SetForeColor(Turbine.UI.Color.Red)
			iconMaint["IconImageSize"..tmpK]:SetText(Resource[Settings.language][331]..":"..tmpImage)
		end
	end
	iconMaint.applyChanges()	
end

iconMaint.EditIcon=function(sender,iconIndex,allowSelect)
	if allowSelect==nil then
		allowSelect=false
	end
	iconMaint:SetVisible(true)
	iconMaint.AnnotType:SetVisible(allowSelect)
	iconMaint.AnnotTypeText:SetVisible(not allowSelect)
	local newIndex=1
	for k=1,iconMaint.AnnotType.ListData:GetItemCount() do
		if iconMaint.AnnotType.ListData:GetItem(k):GetValue()==iconIndex then
			newIndex=k
			break
		end
	end
	iconMaint.AnnotType:SetSelectedIndex(newIndex)
	iconMaint.AnnotType:SelectedIndexChanged()
end

iconMaint.loadImage=function(tmpIndex)
	local tmpK=tostring(tmpIndex)
	tmpImage=string.trim(iconMaint["IconText"..tmpK]:GetText())
	iconMaint["IconText"..tmpK]:SetText(tmpImage)
	if tmpImage~="" then
		if tonumber(tmpImage)==nil then
			success,result=pcall(Turbine.UI.Control.SetBackground,iconMaint["IconImage"..tmpK],resourcePath..tmpImage);
		else
			success,result=pcall(Turbine.UI.Control.SetBackground,iconMaint["IconImage"..tmpK],tonumber(tmpImage));
		end
		if success then
			-- get image x,y
			iconMaint["IconImage"..tmpK]:SetStretchMode(2)
			local x,y=iconMaint["IconImage"..tmpK]:GetSize()
			iconMaint["IconImage"..tmpK]:SetStretchMode(0)
			iconMaint["IconImageSize"..tmpK]:SetText(tostring(x).." x "..tostring(y))
			if x>32 or y>32 then
				iconMaint["IconImageSize"..tmpK]:SetForeColor(Turbine.UI.Color.Red)
				iconMaint["IconImage"..tmpK]:SetPosition(0,0)
			else
				iconMaint["IconImageSize"..tmpK]:SetForeColor(Settings.fontColor)
				iconMaint["IconImage"..tmpK]:SetPosition((32-iconMaint["IconImage"..tmpK]:GetWidth())/2,(32-iconMaint["IconImage"..tmpK]:GetHeight())/2)
			end
			if tmpIndex==1 then
				iconInfo[iconMaint.AnnotType:GetValue()][2]=x
				iconInfo[iconMaint.AnnotType:GetValue()][3]=y
			end
		else
			iconMaint["IconImageSize"..tmpK]:SetForeColor(Turbine.UI.Color.Red)
			iconMaint["IconImageSize"..tmpK]:SetText(Resource[Settings.language][331]..":"..tmpImage)
		end
	end
end
iconMaint.applyChanges=function()
	-- save the icon settings
	local k=iconMaint.AnnotType:GetValue()
	if iconMaint.X~=0 then
		iconInfo[k][2]=iconMaint.X
		iconInfo[k][3]=iconMaint.Y
	end
	local tmpImage=string.trim(iconMaint["IconText1"]:GetText())
	if tonumber(tmpImage)~=nil then
		iconInfo[k][4]=tonumber(tmpImage)
	else
		iconInfo[k][4]=tmpImage
	end
	local tmpImage=string.trim(iconMaint["IconText2"]:GetText())
	if tonumber(tmpImage)~=nil then
		iconInfo[k][5]=tonumber(tmpImage)
	else
		iconInfo[k][5]=tmpImage
	end
	local tmpImage=string.trim(iconMaint["IconText3"]:GetText())
	if tonumber(tmpImage)~=nil then
		iconInfo[k][6]=tonumber(tmpImage)
	else
		iconInfo[k][6]=tmpImage
	end
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
	-- need to find the filter panel icon
	if iconInfo[k][7]~=nil then
		local tmpFilter
		if iconInfo[k][1]==115 then
			-- override "Good Map" with just "Map" since it represents all map-ins
			tmpFilter=mapWindow.FilterPanel.Filters["Map"]
		elseif iconInfo[k][1]==248 then
			-- override "Stair Up" with "Stair"
			tmpFilter=mapWindow.FilterPanel.Filters["Stair"]
		else
			tmpFilter=mapWindow.FilterPanel.Filters[Resource[1][iconInfo[k][1]]]
		end
		tmpImage=iconInfo[k][6]
		if tonumber(tmpImage)==nil then
			success,result=pcall(Turbine.UI.Control.SetBackground,tmpFilter.icon,resourcePath..tmpImage);
		else
			success,result=pcall(Turbine.UI.Control.SetBackground,tmpFilter.icon,tonumber(tmpImage));
		end
	end
end

iconMaint.SetTrimColor=function()
	iconMaint.AnnotType:SetBorderColor(Settings.trimColor);
	iconMaint.Sep1:SetBackColor(Settings.trimColor)
	iconMaint.IconBorder1:SetBackColor(Settings.trimColor)
	iconMaint.IconBorder2:SetBackColor(Settings.trimColor)
	iconMaint.IconBorder3:SetBackColor(Settings.trimColor)
end
iconMaint.SetBackColor=function()
--	Turbine.UI.Lotro.Window.SetBackColor(iconMaint,Settings.backColor)
	iconMaint.AnnotType:SetBackColor(Settings.backColor);
	iconMaint.AnnotType.CurrentValue:SetBackColor(Settings.backColor);
end
iconMaint.SetFontColor=function()
	iconMaint.AnnotTypeCaption:SetForeColor(Settings.fontColor)
	iconMaint.IconCaption1:SetForeColor(Settings.fontColor)
	iconMaint.IconCaption2:SetForeColor(Settings.fontColor)
	iconMaint.IconCaption3:SetForeColor(Settings.fontColor)
end
iconMaint.SetHeadingsColor=function()
end
iconMaint.SetListTextColor=function()
	iconMaint.AnnotType:SetTextColor(Settings.listTextColor);
end
iconMaint.SetLanguage=function()
	iconMaint:SetText(Resource[Settings.language][324])
	iconMaint.AnnotTypeCaption:SetText(Resource[Settings.language][325])
	iconMaint.IconCaption1:SetText(Resource[Settings.language][326])
	iconMaint.IconCaption2:SetText(Resource[Settings.language][327])
	iconMaint.IconCaption3:SetText(Resource[Settings.language][328])
	iconMaint.ApplyButton:SetText(Resource[Settings.language][11])
	iconMaint.DefaultButton:SetText(Resource[Settings.language][332])
end