-- this window is used to maintain the overlays for maps
overlayWindow=Turbine.UI.Lotro.Window();
overlayWindow:SetSize(440,505);
overlayWindow:SetPosition((Turbine.UI.Display:GetWidth()-overlayWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-overlayWindow:GetHeight())/2)
overlayWindow:SetText(Resource[Settings.language][221]);

overlayWindow.MapInfo=Turbine.UI.Control();
overlayWindow.MapInfo:SetParent(overlayWindow);
overlayWindow.MapInfo:SetSize(overlayWindow:GetWidth()-14,65);
overlayWindow.MapInfo:SetPosition(7,45);
overlayWindow.MapInfo:SetBackColor(Settings.trimColor);
overlayWindow.MIBackdrop=Turbine.UI.Control();
overlayWindow.MIBackdrop:SetParent(overlayWindow.MapInfo);
overlayWindow.MIBackdrop:SetSize(overlayWindow.MapInfo:GetWidth()-2,overlayWindow.MapInfo:GetHeight()-2);
overlayWindow.MIBackdrop:SetPosition(1,1);
overlayWindow.MIBackdrop:SetBackColor(Turbine.UI.Color(.05,.1,.15));

overlayWindow.MITitleBack=Turbine.UI.Control();
overlayWindow.MITitleBack:SetParent(overlayWindow);
overlayWindow.MITitleBack:SetSize(80,18);
overlayWindow.MITitleBack:SetPosition(overlayWindow.MapInfo:GetLeft()+overlayWindow.MapInfo:GetWidth()/2-40,overlayWindow.MapInfo:GetTop()-9);
overlayWindow.MITitleBack:SetBackColor(Settings.trimColor);
overlayWindow.MITitle=Turbine.UI.Label();
overlayWindow.MITitle:SetParent(overlayWindow.MITitleBack);
overlayWindow.MITitle:SetSize(78,16);
overlayWindow.MITitle:SetPosition(1,1);
overlayWindow.MITitle:SetFont(Turbine.UI.Lotro.Font.Verdana12);
overlayWindow.MITitle:SetForeColor(Settings.headingsColor)
overlayWindow.MITitle:SetBackColor(Turbine.UI.Color(0,0,0));
overlayWindow.MITitle:SetText(Resource[Settings.language][224]);
overlayWindow.MITitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

overlayWindow.NameCaption=Turbine.UI.Label();
overlayWindow.NameCaption:SetParent(overlayWindow.MapInfo);
overlayWindow.NameCaption:SetSize(80,20);
overlayWindow.NameCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.NameCaption:SetForeColor(Settings.fontColor)
overlayWindow.NameCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.NameCaption:SetText(Resource[Settings.language][77]);
overlayWindow.NameCaption:SetPosition(2,12);
overlayWindow.Name=Turbine.UI.Label();
overlayWindow.Name:SetParent(overlayWindow.MapInfo);
overlayWindow.Name:SetSize(200,20);
overlayWindow.Name:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.Name:SetPosition(83,12);
overlayWindow.Name:SetForeColor(Settings.fontColor)
overlayWindow.Name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

overlayWindow.SizeCaption=Turbine.UI.Label();
overlayWindow.SizeCaption:SetParent(overlayWindow.MapInfo);
overlayWindow.SizeCaption:SetSize(80,20);
overlayWindow.SizeCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.SizeCaption:SetForeColor(Settings.fontColor)
overlayWindow.SizeCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.SizeCaption:SetText(Resource[Settings.language][222]);
overlayWindow.SizeCaption:SetPosition(2,37);
overlayWindow.MapW=Turbine.UI.Label();
overlayWindow.MapW:SetParent(overlayWindow.MapInfo);
overlayWindow.MapW:SetSize(40,20);
overlayWindow.MapW:SetPosition(83,37);
overlayWindow.MapW:SetForeColor(Settings.fontColor)
overlayWindow.MapW:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.SizeX=Turbine.UI.Label();
overlayWindow.SizeX:SetParent(overlayWindow.MapInfo);
overlayWindow.SizeX:SetSize(8,20);
overlayWindow.SizeX:SetForeColor(Settings.fontColor)
overlayWindow.SizeX:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.SizeX:SetText("X");
overlayWindow.SizeX:SetPosition(125,37);
overlayWindow.MapH=Turbine.UI.Label();
overlayWindow.MapH:SetParent(overlayWindow.MapInfo);
overlayWindow.MapH:SetSize(40,20);
overlayWindow.MapH:SetPosition(135,37);
overlayWindow.MapH:SetForeColor(Settings.fontColor)
overlayWindow.MapH:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

overlayWindow.OverlayInfo=Turbine.UI.Control()
overlayWindow.OverlayInfo:SetParent(overlayWindow);
overlayWindow.OverlayInfo:SetSize(overlayWindow:GetWidth()-14,170);
overlayWindow.OverlayInfo:SetPosition(7,overlayWindow.MapInfo:GetTop()+overlayWindow.MapInfo:GetHeight()+15);
overlayWindow.OverlayInfo:SetBackColor(Settings.trimColor);
overlayWindow.OLBackdrop=Turbine.UI.Control();
overlayWindow.OLBackdrop:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLBackdrop:SetSize(overlayWindow.OverlayInfo:GetWidth()-2,overlayWindow.OverlayInfo:GetHeight()-2);
overlayWindow.OLBackdrop:SetPosition(1,1);
overlayWindow.OLBackdrop:SetBackColor(Turbine.UI.Color(.05,.1,.15));

overlayWindow.OLTitleBack=Turbine.UI.Control();
overlayWindow.OLTitleBack:SetParent(overlayWindow);
overlayWindow.OLTitleBack:SetSize(80,18);
overlayWindow.OLTitleBack:SetPosition(overlayWindow.OverlayInfo:GetLeft()+overlayWindow.OverlayInfo:GetWidth()/2-40,overlayWindow.OverlayInfo:GetTop()-9);
overlayWindow.OLTitleBack:SetBackColor(Settings.trimColor);
overlayWindow.OLTitle=Turbine.UI.Label();
overlayWindow.OLTitle:SetParent(overlayWindow.OLTitleBack);
overlayWindow.OLTitle:SetSize(78,16);
overlayWindow.OLTitle:SetPosition(1,1);
overlayWindow.OLTitle:SetFont(Turbine.UI.Lotro.Font.Verdana12);
overlayWindow.OLTitle:SetForeColor(Settings.headingsColor)
overlayWindow.OLTitle:SetBackColor(Turbine.UI.Color(0,0,0));
overlayWindow.OLTitle:SetText(Resource[Settings.language][219]);
overlayWindow.OLTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

overlayWindow.SelectCaption=Turbine.UI.Label();
overlayWindow.SelectCaption:SetParent(overlayWindow.OverlayInfo);
overlayWindow.SelectCaption:SetSize(80,20);
overlayWindow.SelectCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.SelectCaption:SetForeColor(Settings.fontColor)
overlayWindow.SelectCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.SelectCaption:SetText(Resource[Settings.language][219]);
overlayWindow.SelectCaption:SetPosition(2,12);
overlayWindow.OLSelect=DropDownList();
overlayWindow.OLSelect:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLSelect:SetZOrder(overlayWindow.OLSelect:GetZOrder()+1);
overlayWindow.OLSelect:SetSize(200,20);
overlayWindow.OLSelect:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.OLSelect:SetPosition(83,12);
overlayWindow.OLSelect:SetBorderColor(Settings.trimColor);
overlayWindow.OLSelect:SetBackColor(Settings.backColor);
overlayWindow.OLSelect:SetTextColor(Settings.listTextColor)
overlayWindow.OLSelect.CurrentValue:SetBackColor(Settings.backColor);
overlayWindow.OLSelect:SetTextColor(Settings.listTextColor);
overlayWindow.OLSelect:SetDropRows(6);

popOL=function()
	local tmpOL={};
	overlayWindow.OLSelect:ClearList(); -- savely remove entries and event handlers
	overlayWindow.OLSelect:AddItem(Resource[Settings.language][79],0)
	for index,data in ipairs(overlays) do
		if data[1]==mapWindow.CurrentMapID then
			tmpOL[#tmpOL+1]={data[2],index}
		end
	end
	table.sort(tmpOL,function(arg1,arg2) if arg1[1]<arg2[1] then return (true) end end)
	for index,data in ipairs(tmpOL) do
		overlayWindow.OLSelect:AddItem(data[1],data[2]);
	end
end
overlayWindow.OLSelect.SelectedIndexChanged=function()
	local overlayID=overlayWindow.OLSelect:GetValue();
	local editable=true
	if overlayID>0 and overlays[overlayID]~=nil then
		overlayWindow.OLName:SetText(overlays[overlayID][2]);
		overlayWindow.OLName2:SetText(overlays[overlayID][2]);
		overlayWindow.FileName:SetText(overlays[overlayID][3]);
		overlayWindow.OLL:SetText(overlays[overlayID][6]);
		overlayWindow.OLT:SetText(overlays[overlayID][7]);
		overlayWindow.FileName.oldText="";
		overlayWindow.FileName:Update();
		if overlays[overlayID][10]==nil then overlays[overlayID][10]=1 end
		overlayWindow.OLOpacity:SetValue(overlays[overlayID][10]*100);
		if overlays[overlayID][2]=="Berry's Deed Data" then
			-- since this is a data driven overlay it can not be altered or it will cease to work
			editable=false
		end
	end
	overlayWindow.OLName:SetVisible(editable)
	overlayWindow.OLName2:SetVisible(not editable)
	overlayWindow.FileName:SetVisible(editable)
	overlayWindow.OLL:SetVisible(editable)
	overlayWindow.OLT:SetVisible(editable)

	overlayWindow.OLSave:SetEnabled(editable);
	overlayWindow.OLDelete:SetEnabled(overlayID>0 and editable);
end
overlayWindow.OLSelect:SetSelectedIndex(1);

overlayWindow.OLSave=Turbine.UI.Lotro.Button();
overlayWindow.OLSave:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLSave:SetSize(70,20);
overlayWindow.OLSave:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.OLSave:SetPosition(285,12)
overlayWindow.OLSave:SetText(Resource[Settings.language][11]);
overlayWindow.OLSave.Click=function()
	local tmpIndex=overlayWindow.OLSelect:GetSelectedIndex();
	local tmpOLIndex=overlayWindow.OLSelect:GetValue()
	if tmpOLIndex==0 then
		-- add a new overlay
		-- update tmpIndex to the new overlay's index
		tmpOLIndex=#overlays+1;
		overlays[tmpOLIndex]={mapWindow.CurrentMapID}
		overlays[tmpOLIndex][8]=true;
		tmpIndex=overlayWindow.OLSelect.ListData:GetItemCount()+1;
		overlays[tmpOLIndex][9]=tmpIndex-1; -- don't count the "New" entry
		overlayWindow.OLSelect:AddItem(overlayWindow.OLName:GetText(),tmpOLIndex);
	end
	overlays[tmpOLIndex][2]=overlayWindow.OLName:GetText();
	overlays[tmpOLIndex][3]=overlayWindow.FileName:GetText();
	overlays[tmpOLIndex][4]=tonumber(overlayWindow.OLW:GetText());
	overlays[tmpOLIndex][5]=tonumber(overlayWindow.OLH:GetText());
	overlays[tmpOLIndex][6]=tonumber(overlayWindow.OLL:GetText());
	overlays[tmpOLIndex][7]=tonumber(overlayWindow.OLT:GetText());
	overlays[tmpOLIndex][10]=overlayWindow.OLOpacity:GetValue()/100;
	mapWindow:LoadOverlays();
--	popOL();
	overlayWindow.refreshOLList();
	overlayWindow.OLDelete:SetEnabled(true);
	overlayWindow.OLSelect:SetSelectedIndex(tmpIndex);
end

overlayWindow.OLDelete=Turbine.UI.Lotro.Button();
overlayWindow.OLDelete:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLDelete:SetSize(70,20);
overlayWindow.OLDelete:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.OLDelete:SetPosition(354,12);
overlayWindow.OLDelete:SetEnabled(false);
overlayWindow.OLDelete:SetText(Resource[Settings.language][84]);
overlayWindow.OLDelete.Click=function()
	local tmpIndex=overlayWindow.OLSelect:GetSelectedIndex()
	local tmpOLIndex=overlayWindow.OLSelect:GetValue()
	if tmpOLIndex>0 then
		local tmpLayer=overlays[tmpOLIndex][9];
		table.remove(overlays,tmpOLIndex)
		for index,data in ipairs(overlays) do
			if data[1]==mapWindow.CurrentMapID and data[9]>=tmpLayer then
				overlays[index][9]=data[9]-1;
			end
		end
		mapWindow:LoadOverlays();
		popOL(); -- easier to repop than recalc the indexes
		overlayWindow.refreshOLList();
		if tmpIndex>overlayWindow.OLSelect.ListData:GetItemCount() then
			tmpIndex=overlayWindow.OLSelect.ListData:GetItemCount();
		end
		overlayWindow.OLDelete:SetEnabled(tmpIndex>1);
		overlayWindow.OLSelect:SetSelectedIndex(tmpIndex);
	end
end

overlayWindow.Sep1=Turbine.UI.Control();
overlayWindow.Sep1:SetParent(overlayWindow.OverlayInfo);
overlayWindow.Sep1:SetSize(overlayWindow.OverlayInfo:GetWidth()-10,1);
overlayWindow.Sep1:SetPosition(5,37);
overlayWindow.Sep1:SetBackColor(Settings.trimColor);

overlayWindow.OLCaption=Turbine.UI.Label();
overlayWindow.OLCaption:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLCaption:SetSize(80,20);
overlayWindow.OLCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.OLCaption:SetForeColor(Settings.fontColor)
overlayWindow.OLCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.OLCaption:SetText(Resource[Settings.language][77]);
overlayWindow.OLCaption:SetPosition(2,42);

overlayWindow.OLName2=Turbine.UI.Label();
overlayWindow.OLName2:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLName2:SetSize(200,20);
overlayWindow.OLName2:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.OLName2:SetPosition(83,42);
overlayWindow.OLName2:SetForeColor(Settings.fontColor)
overlayWindow.OLName2:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.OLName2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

overlayWindow.OLName=Turbine.UI.Lotro.TextBox();
overlayWindow.OLName:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLName:SetSize(200,20);
overlayWindow.OLName:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.OLName:SetPosition(83,42);
overlayWindow.OLName:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.OLName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

overlayWindow.FileCaption=Turbine.UI.Label();
overlayWindow.FileCaption:SetParent(overlayWindow.OverlayInfo);
overlayWindow.FileCaption:SetSize(80,20);
overlayWindow.FileCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.FileCaption:SetForeColor(Settings.fontColor)
overlayWindow.FileCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.FileCaption:SetText(Resource[Settings.language][225]);
overlayWindow.FileCaption:SetPosition(2,67);
overlayWindow.FileName=Turbine.UI.Lotro.TextBox();
overlayWindow.FileName:SetParent(overlayWindow.OverlayInfo);
overlayWindow.FileName:SetSize(200,20);
overlayWindow.FileName:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.FileName:SetPosition(83,67);
overlayWindow.FileName:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.FileName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.FileName.FocusGained=function()
	overlayWindow.FileName:SetWantsUpdates(true);
end
overlayWindow.FileName.FocusLost=function()
	overlayWindow.FileName:SetWantsUpdates(false);
end
overlayWindow.FileName.Update=function()
	local newName=overlayWindow.FileName:GetText();
	if newName~=overlayWindow.FileName.oldText then
		overlayWindow.OLW:SetText("");
		overlayWindow.OLH:SetText("");
		if string.find(string.lower(newName),".jpg")~= nil or string.find(string.lower(newName),".tga")~=nil then
			local path="GaranStuff/MoorMap/Overlays/"..newName;
			-- try to load the image
			local tmpImage=Turbine.UI.Control()
			local success,result=pcall(Turbine.UI.Control.SetBackground,tmpImage,path)
			if success then
				tmpImage:SetStretchMode(2);
				local w,h=tmpImage:GetSize();
				overlayWindow.OLW:SetText(w);
				overlayWindow.OLH:SetText(h);
			end
		end
		overlayWindow.FileName.oldText=newName;
	end
end

overlayWindow.OLSizeCaption=Turbine.UI.Label();
overlayWindow.OLSizeCaption:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLSizeCaption:SetSize(80,20);
overlayWindow.OLSizeCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.OLSizeCaption:SetForeColor(Settings.fontColor)
overlayWindow.OLSizeCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.OLSizeCaption:SetText(Resource[Settings.language][222]);
overlayWindow.OLSizeCaption:SetPosition(2,92);
overlayWindow.OLW=Turbine.UI.Label();
overlayWindow.OLW:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLW:SetSize(40,20);
overlayWindow.OLW:SetPosition(83,92);
overlayWindow.OLW:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.OLW:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.OLSizeX=Turbine.UI.Label();
overlayWindow.OLSizeX:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLSizeX:SetSize(8,20);
overlayWindow.OLSizeX:SetForeColor(Settings.fontColor)
overlayWindow.OLSizeX:SetText("X");
overlayWindow.OLSizeX:SetPosition(125,92);
overlayWindow.OLSizeX:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.OLH=Turbine.UI.Label();
overlayWindow.OLH:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLH:SetSize(40,20);
overlayWindow.OLH:SetPosition(135,92);
overlayWindow.OLH:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.OLH:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

overlayWindow.OLPosCaption=Turbine.UI.Label();
overlayWindow.OLPosCaption:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLPosCaption:SetSize(80,20);
overlayWindow.OLPosCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.OLPosCaption:SetForeColor(Settings.fontColor)
overlayWindow.OLPosCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.OLPosCaption:SetText(Resource[Settings.language][223]);
overlayWindow.OLPosCaption:SetPosition(2,117);
overlayWindow.OLL=Turbine.UI.Lotro.TextBox();
overlayWindow.OLL:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLL:SetSize(40,20);
overlayWindow.OLL:SetPosition(83,117);
overlayWindow.OLL:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.OLL:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.OLPosX=Turbine.UI.Label();
overlayWindow.OLPosX:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLPosX:SetSize(8,20);
overlayWindow.OLPosX:SetForeColor(Settings.fontColor)
overlayWindow.OLPosX:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.OLPosX:SetText(",");
overlayWindow.OLPosX:SetPosition(125,117);
overlayWindow.OLT=Turbine.UI.Lotro.TextBox();
overlayWindow.OLT:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLT:SetSize(40,20);
overlayWindow.OLT:SetPosition(135,117);
overlayWindow.OLT:SetFont(Turbine.UI.Lotro.Font.Verdana16);
overlayWindow.OLT:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

overlayWindow.OLOpacityCaption=Turbine.UI.Label();
overlayWindow.OLOpacityCaption:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLOpacityCaption:SetSize(80,20);
overlayWindow.OLOpacityCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
overlayWindow.OLOpacityCaption:SetForeColor(Settings.fontColor)
overlayWindow.OLOpacityCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
overlayWindow.OLOpacityCaption:SetText(Resource[Settings.language][71]);
overlayWindow.OLOpacityCaption:SetPosition(2,142);
overlayWindow.OLOpacity=Turbine.UI.Lotro.ScrollBar();
overlayWindow.OLOpacity:SetParent(overlayWindow.OverlayInfo);
overlayWindow.OLOpacity:SetPosition(overlayWindow.FileName:GetLeft(),overlayWindow.OLOpacityCaption:GetTop()+5);
overlayWindow.OLOpacity:SetSize(overlayWindow.OverlayInfo:GetWidth()-overlayWindow.OLOpacity:GetLeft()-10,10);
overlayWindow.OLOpacity:SetMinimum(0);
overlayWindow.OLOpacity:SetMaximum(100);
overlayWindow.OLOpacity:SetValue(100);

overlayWindow.DLBack=Turbine.UI.Control();
overlayWindow.DLBack:SetParent(overlayWindow);
overlayWindow.DLBack:SetSize(overlayWindow:GetWidth()-14,160);
overlayWindow.DLBack:SetPosition(7,overlayWindow.OverlayInfo:GetTop()+overlayWindow.OverlayInfo:GetHeight()+15);
overlayWindow.DLBack:SetBackColor(Settings.trimColor);
overlayWindow.DLBackdrop=Turbine.UI.Control();
overlayWindow.DLBackdrop:SetParent(overlayWindow.DLBack);
overlayWindow.DLBackdrop:SetSize(overlayWindow.DLBack:GetWidth()-2,overlayWindow.DLBack:GetHeight()-2);
overlayWindow.DLBackdrop:SetPosition(1,1);
overlayWindow.DLBackdrop:SetBackColor(Turbine.UI.Color(.05,.1,.15));

overlayWindow.DLTitleBack=Turbine.UI.Control();
overlayWindow.DLTitleBack:SetParent(overlayWindow);
overlayWindow.DLTitleBack:SetSize(80,18);
overlayWindow.DLTitleBack:SetPosition(overlayWindow.DLBack:GetLeft()+overlayWindow.DLBack:GetWidth()/2-40,overlayWindow.DLBack:GetTop()-9);
overlayWindow.DLTitleBack:SetBackColor(Settings.trimColor);
overlayWindow.DLTitle=Turbine.UI.Label();
overlayWindow.DLTitle:SetParent(overlayWindow.DLTitleBack);
overlayWindow.DLTitle:SetSize(78,16);
overlayWindow.DLTitle:SetPosition(1,1);
overlayWindow.DLTitle:SetFont(Turbine.UI.Lotro.Font.Verdana12);
overlayWindow.DLTitle:SetForeColor(Settings.headingsColor)
overlayWindow.DLTitle:SetBackColor(Turbine.UI.Color(0,0,0));
overlayWindow.DLTitle:SetText(Resource[Settings.language][226]);
overlayWindow.DLTitle:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

overlayWindow.DLList=Turbine.UI.ListBox();
overlayWindow.DLList:SetParent(overlayWindow.DLBack);
overlayWindow.DLList:SetSize(overlayWindow.DLBack:GetWidth()-49,overlayWindow.DLBack:GetHeight()-2);
overlayWindow.DLList:SetPosition(1,1);
overlayWindow.DLList:SetBackColor(Turbine.UI.Color(.1,0,0));

overlayWindow.refreshOLList=function()
	local tmpOL={};
	overlayWindow.DLList:ClearItems();
	for index,data in ipairs(overlays) do
		if data[1]==mapWindow.CurrentMapID then
			tmpOL[#tmpOL+1]={index,data[2],data[8],data[9]};
		end
	end
	table.sort(tmpOL,function(arg1,arg2) if arg1[4]>arg2[4] then return true end end)
	for index,data in ipairs(tmpOL) do
		local tmpRow=Turbine.UI.Control();
		tmpRow:SetParent(overlayWindow.DLList);
		tmpRow:SetSize(overlayWindow.DLList:GetWidth(),20);
		tmpRow:SetBackColor(Turbine.UI.Color(0,0,0));
		tmpRow.CB=Turbine.UI.Lotro.CheckBox();
		tmpRow.CB:SetParent(tmpRow);
		tmpRow.CB:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		tmpRow.CB:SetSize(18,20);
		tmpRow.CB:SetLeft(1)
		tmpRow.CB:SetChecked(data[3]);
		tmpRow.CB.OLIndex=data[1];

		tmpRow.Lbl=Turbine.UI.Label();
		tmpRow.Lbl:SetParent(tmpRow);
		tmpRow.Lbl:SetFont(Turbine.UI.Lotro.Font.Verdana16);
		tmpRow.Lbl:SetSize(overlayWindow.DLList:GetWidth()-19,20);
		tmpRow.Lbl:SetLeft(19)
		tmpRow.Lbl:SetText(data[2]);
		tmpRow.Lbl.OLIndex=data[1];

		tmpRow.CB.CheckedChanged=function(sender)
			overlays[sender.OLIndex][8]=not overlays[sender.OLIndex][8];
			mapWindow:LoadOverlays();
		end
		overlayWindow.DLList:AddItem(tmpRow);
	end
	overlayWindow.DLList.SelectedIndexChanged=function()
		if overlayWindow.DLList.OldSelectedIndex~=nil then
			overlayWindow.DLList:GetItem(overlayWindow.DLList.OldSelectedIndex):SetBackColor(Turbine.UI.Color(0,0,0));
		end
		overlayWindow.DLList.OldSelectedIndex=overlayWindow.DLList:GetSelectedIndex();
		overlayWindow.DLList:GetItem(overlayWindow.DLList.OldSelectedIndex):SetBackColor(Turbine.UI.Color(.2,.2,.2));
		overlayWindow.DLMoveUp:SetEnabled(overlayWindow.DLList.OldSelectedIndex>1);
		overlayWindow.DLMoveDown:SetEnabled(overlayWindow.DLList.OldSelectedIndex<overlayWindow.DLList:GetItemCount());
	end
	if overlayWindow.DLList:GetItemCount()>0 then
		overlayWindow.DLList.OldSelectedIndex=1;
		overlayWindow.DLList:GetItem(1):SetBackColor(Turbine.UI.Color(.2,.2,.2));
		overlayWindow.DLList:SetSelectedIndex(0);
		overlayWindow.DLList:SetSelectedIndex(1);
	else
		overlayWindow.DLMoveUp:SetEnabled(false);
		overlayWindow.DLMoveDown:SetEnabled(false);
	end
end

overlayWindow.DLScroll=Turbine.UI.Lotro.ScrollBar();
overlayWindow.DLScroll:SetParent(overlayWindow.DLBack);
overlayWindow.DLScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
overlayWindow.DLScroll:SetSize(12,overlayWindow.DLList:GetHeight());
overlayWindow.DLScroll:SetPosition(overlayWindow.DLList:GetLeft()+overlayWindow.DLList:GetWidth(),overlayWindow.DLList:GetTop());
overlayWindow.DLList:SetVerticalScrollBar(overlayWindow.DLScroll);

overlayWindow.DLMoveUp=Turbine.UI.Label();
overlayWindow.DLMoveUp:SetParent(overlayWindow.DLBack);
overlayWindow.DLMoveUp:SetSize(32,32);
overlayWindow.DLMoveUp:SetPosition(overlayWindow.DLScroll:GetLeft()+overlayWindow.DLScroll:GetWidth()+2,overlayWindow.DLList:GetTop()+overlayWindow.DLList:GetHeight()/2-40);
overlayWindow.DLMoveUp:SetText(Resource[Settings.language][358]);
overlayWindow.DLMoveUp.EnabledChanged=function()
	overlayWindow.DLMoveUp:SetVisible(overlayWindow.DLMoveUp:IsEnabled())
end
overlayWindow.DLMoveUp.MouseClick=function()
	-- find overlay above this one
	local tmpIndex1=overlayWindow.DLList:GetSelectedIndex();
	local tmpIndex2=tmpIndex1-1;
	overlays[overlayWindow.DLList:GetItem(tmpIndex1).CB.OLIndex][9]=overlays[overlayWindow.DLList:GetItem(tmpIndex1).CB.OLIndex][9]+1
	overlays[overlayWindow.DLList:GetItem(tmpIndex2).CB.OLIndex][9]=overlays[overlayWindow.DLList:GetItem(tmpIndex2).CB.OLIndex][9]-1
	mapWindow:LoadOverlays();
--	popOL();
	overlayWindow.refreshOLList();
	overlayWindow.DLList:SetSelectedIndex(tmpIndex2);
end

overlayWindow.DLMoveDown=Turbine.UI.Label();
overlayWindow.DLMoveDown:SetParent(overlayWindow.DLBack);
overlayWindow.DLMoveDown:SetSize(32,32);
overlayWindow.DLMoveDown:SetPosition(overlayWindow.DLScroll:GetLeft()+overlayWindow.DLScroll:GetWidth()+2,overlayWindow.DLList:GetTop()+overlayWindow.DLList:GetHeight()/2+8);
overlayWindow.DLMoveDown:SetText(Resource[Settings.language][359]);
overlayWindow.DLMoveDown.EnabledChanged=function()
	overlayWindow.DLMoveDown:SetVisible(overlayWindow.DLMoveDown:IsEnabled())
end
overlayWindow.DLMoveDown.MouseClick=function()
	-- find overlay above this one
	local tmpIndex1=overlayWindow.DLList:GetSelectedIndex();
	local tmpIndex2=tmpIndex1+1;
	overlays[overlayWindow.DLList:GetItem(tmpIndex1).CB.OLIndex][9]=overlays[overlayWindow.DLList:GetItem(tmpIndex1).CB.OLIndex][9]-1
	overlays[overlayWindow.DLList:GetItem(tmpIndex2).CB.OLIndex][9]=overlays[overlayWindow.DLList:GetItem(tmpIndex2).CB.OLIndex][9]+1
	mapWindow:LoadOverlays();
--	popOL();
	overlayWindow.refreshOLList();
	overlayWindow.DLList:SetSelectedIndex(tmpIndex2);
end

overlayWindow.SetLanguage=function()
	overlayWindow:SetText(Resource[Settings.language][221]);
	overlayWindow.MITitle:SetText(Resource[Settings.language][224]);
	overlayWindow.NameCaption:SetText(Resource[Settings.language][77]);
	overlayWindow.Name:SetText(Resource[Settings.language][mapInfo[mapWindow.CurrentMapID][2]]);
	overlayWindow.SizeCaption:SetText(Resource[Settings.language][222]);
	overlayWindow.OLTitle:SetText(Resource[Settings.language][219]);
	overlayWindow.SelectCaption:SetText(Resource[Settings.language][219]);
	overlayWindow.OLSave:SetText(Resource[Settings.language][11]);
	overlayWindow.OLDelete:SetText(Resource[Settings.language][84]);
	overlayWindow.OLCaption:SetText(Resource[Settings.language][77]);
	overlayWindow.FileCaption:SetText(Resource[Settings.language][225]);
	overlayWindow.OLSizeCaption:SetText(Resource[Settings.language][222]);
	overlayWindow.OLPosCaption:SetText(Resource[Settings.language][223]);
end

overlayWindow.SetTrimColor=function()
	overlayWindow.MapInfo:SetBackColor(Settings.trimColor);
	overlayWindow.MITitleBack:SetBackColor(Settings.trimColor);
	overlayWindow.OverlayInfo:SetBackColor(Settings.trimColor);
	overlayWindow.OLTitleBack:SetBackColor(Settings.trimColor);
	overlayWindow.OLSelect:SetBorderColor(Settings.trimColor);
	overlayWindow.Sep1:SetBackColor(Settings.trimColor);
	overlayWindow.DLBack:SetBackColor(Settings.trimColor);
	overlayWindow.DLTitleBack:SetBackColor(Settings.trimColor);
end
overlayWindow.SetBackColor=function()
	overlayWindow.OLSelect:SetBackColor(Settings.backColor);
	overlayWindow.OLSelect.CurrentValue:SetBackColor(Settings.backColor);
end
overlayWindow.SetFontColor=function()
	overlayWindow.NameCaption:SetForeColor(Settings.fontColor)
	overlayWindow.Name:SetForeColor(Settings.fontColor)
	overlayWindow.SizeCaption:SetForeColor(Settings.fontColor)
	overlayWindow.MapW:SetForeColor(Settings.fontColor)
	overlayWindow.SizeX:SetForeColor(Settings.fontColor)
	overlayWindow.MapH:SetForeColor(Settings.fontColor)
	overlayWindow.SelectCaption:SetForeColor(Settings.fontColor)
	overlayWindow.OLCaption:SetForeColor(Settings.fontColor)
	overlayWindow.OLName2:SetForeColor(Settings.fontColor)
	overlayWindow.FileCaption:SetForeColor(Settings.fontColor)
	overlayWindow.OLSizeCaption:SetForeColor(Settings.fontColor)
	overlayWindow.OLSizeX:SetForeColor(Settings.fontColor)
	overlayWindow.OLPosCaption:SetForeColor(Settings.fontColor)
	overlayWindow.OLPosX:SetForeColor(Settings.fontColor)
	overlayWindow.OLOpacityCaption:SetForeColor(Settings.fontColor)
end
overlayWindow.SetHeadingsColor=function()
	overlayWindow.MITitle:SetForeColor(Settings.headingsColor)
	overlayWindow.OLTitle:SetForeColor(Settings.headingsColor)
	overlayWindow.DLTitle:SetForeColor(Settings.headingsColor)
end
overlayWindow.SetListTextColor=function()
	overlayWindow.OLSelect:SetTextColor(Settings.listTextColor)
end
