-- create a bogus window just to get an update handler
test=Turbine.UI.Window()
--limit test annotations to the ns/ew bounds of Archet -24.2,-50.8,-28.4,-45.2
test.nsMin=-27.4
test.nsMax=-25.4
test.ewMin=-49.3
test.ewMax=-46.8
test.ns=test.nsMin
test.ew=test.ewMin
test.saving=false
-- archet
-- need a 40x50 grid 28.4-24.2=4.2 ns 4.2, 50.8-45.2=5.6 ew
-- snowborn
-- -59.3,-64.0,-62.4,-59.9
test.count=0
test.Update=function()
	if test.saving then
		if Turbine.Shell.IsCommand("0MMCC") then
			Turbine.PluginManager.UnloadScriptState("MMCust")
			Turbine.Shell.RemoveCommand(test.cmd)
			test.cmd=nil
			test.saving=false
		end
	else
		-- create an annotation at location
		local cmdStr
		cmdStr="0MMCD_SM_1_"..tostring(test.ns).."_"..tostring(test.ew).."_55_0_test_test"
		test.cmd=Turbine.ShellCommand()
		Turbine.Shell.AddCommand(cmdStr,test.cmd)

		test.count=test.count+1
		test.ns=test.ns+.05
		if test.ns>test.nsMax then
			test.ns=test.nsMin
			test.ew=test.ew+.05
Turbine.Shell.WriteLine("annots created:"..tostring(test.count))
		end
		if test.ew>test.ewMax then
			test:SetWantsUpdates(false)
Turbine.Shell.WriteLine("All "..tostring(test.count).." annots created")
test=nil
		else
			test.saving=true
			-- launch MMCust
			Turbine.PluginManager.LoadPlugin("MMCust")
		end
	end
end
test:SetWantsUpdates(true)
Turbine.Shell.WriteLine("creating test annots")

