-- include flowers for essences?

-- need to assign locale since it is out of scope
locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
end

craftTier={} --{EN,FR,DE,RU}
craftTier[1]={"Apprentice","Apprenti","Lehrling"}
craftTier[2]={"Journeyman","Compagnon","Giselle"}
craftTier[3]={"Expert","Expert","Experte"}
craftTier[4]={"Artisan","Artisan","Virtuose"}
craftTier[5]={"Master","Ma\195\172tre","Meister"}
craftTier[6]={"Supreme","Supr\195\168me","\195\156berragend"}
craftTier[7]={"Westfold","Ouestfolde","Westfold"}
craftTier[8]={"Eastemnet","Estemnet","Ost-Emnet"}
craftTier[9]={"Westemnet","Ouestemnet","West-Emnet"}
craftTier[10]={"An\195\180rien","An\195\180rien","An\195\180rien"}
craftTier[11]={"Doomfold","Folde du Destin","Unheilskluft"}
craftTier[12]={"Ironfold","Crevasse de Fer","Eisenbruch"}
craftTier[13]={"Minas Ithil","Minas Ithil","Minas Ithil"}

if locale=="en" then
	-- ore
	table.insert(nodeTier,{"Copper Deposit",43,1,0});
	table.insert(nodeTier,{"Rich Copper Deposit",43,1,0});
	table.insert(nodeTier,{"Barrow-iron Deposit",43,2,0});
	table.insert(nodeTier,{"Rich Barrow-iron Deposit",43,2,0});
	table.insert(nodeTier,{"Silver Deposit",43,2,0});
	table.insert(nodeTier,{"Rich Silver Deposit",43,2,0});
	table.insert(nodeTier,{"Rich Iron Deposit",43,3,0});
	table.insert(nodeTier,{"Bountiful Iron Deposit",43,3,0});
	table.insert(nodeTier,{"Gold Deposit",43,3,0});
	table.insert(nodeTier,{"Rich Gold Deposit",43,3,0});
	table.insert(nodeTier,{"Dwarf-iron Deposit",43,4,0});
	table.insert(nodeTier,{"Rich Dwarf-iron Deposit",43,4,0});
	table.insert(nodeTier,{"Platinum Deposit",43,4,0});
	table.insert(nodeTier,{"Rich Platinum Deposit",43,4,0});
	table.insert(nodeTier,{"Ancient Iron Deposit",43,5,0});
	table.insert(nodeTier,{"Rich Ancient Iron Deposit",43,5,0});
	table.insert(nodeTier,{"Ancient Silver Deposit",43,5,0});
	table.insert(nodeTier,{"Rich Ancient Silver Deposit",43,5,0});
	table.insert(nodeTier,{"Khaz\195\162d Skarn Deposit",43,6,0});
	table.insert(nodeTier,{"Rich Khaz\195\162d Skarn Deposit",43,6,0});
	table.insert(nodeTier,{"Rich Skarn Deposit",43,7,0});
	table.insert(nodeTier,{"Skarn Deposit",43,7,0});
	table.insert(nodeTier,{"Rich Riddermark Deposit",43,8,0});
	table.insert(nodeTier,{"Riddermark Deposit",43,8,0});
	table.insert(nodeTier,{"Eorlingas Skarn Deposit",43,9,0});
	table.insert(nodeTier,{"Rich Eorlingas Skarn Deposit",43,9,0});
	table.insert(nodeTier,{"An\195\179rien Skarn Deposit",43,10,0});
	table.insert(nodeTier,{"Rich An\195\179rien Skarn Deposit",43,10,0});

-- U20 & 21 nodes -- need FR/DE translations
	table.insert(nodeTier,{"Dagorlad Scrap Deposit",43,10,0});
	table.insert(nodeTier,{"Rich Dagorlad Scrap Deposit",43,10,0});
	table.insert(nodeTier,{"Gorgoroth Skarn Deposit",43,11,0});
	table.insert(nodeTier,{"Rich Gorgoroth Skarn Deposit",43,11,0});
-- U22 nodes
	table.insert(nodeTier,{"Erebor Skarn Deposit",43,11,0});
	table.insert(nodeTier,{"Rich Erebor Skarn Deposit",43,11,0});
-- U23 nodes
	table.insert(nodeTier,{"Ironfold Skarn Deposit",43,12,0});
	table.insert(nodeTier,{"Rich Ironfold Skarn Deposit",43,12,0});
-- U24
	table.insert(nodeTier,{"Vales Skarn Deposit",43,12,0}); -- yields same as Ironfold Skarn
	table.insert(nodeTier,{"Rich Vales Skarn Deposit",43,12,0});
--U25
	table.insert(nodeTier,{"Ithil Skarn Deposit",43,13,0});
	table.insert(nodeTier,{"Rich Ithil Skarn Deposit",43,13,0});
	table.insert(nodeTier,{"Langflood Skarn Deposit",43,13,0});
	table.insert(nodeTier,{"Rich Langflood Skarn Deposit",43,13,0});
	table.insert(nodeTier,{"Khaz\195\162d-silver Deposit",43,13,0});
	table.insert(nodeTier,{"Rich Khaz\195\162d-silver Deposit",43,13,0});

	table.insert(nodeTier,{"Gundabad Skarn Deposit",43,14,0});
	table.insert(nodeTier,{"Rich Gundabad Skarn Deposit",43,14,0});

	-- wood
	table.insert(nodeTier,{"Rowan Branches",44,1,0});
	table.insert(nodeTier,{"Heavy Rowan Branches",44,1,0});
	table.insert(nodeTier,{"Ash Branches",44,2,0});
	table.insert(nodeTier,{"Heavy Ash Branches",44,2,0});
	table.insert(nodeTier,{"Yew Branches",44,3,0});
	table.insert(nodeTier,{"Heavy Yew Branches",44,3,0});
	table.insert(nodeTier,{"Lebethron Branches",44,4,0});
	table.insert(nodeTier,{"Heavy Lebethron Branches",44,4,0});
	table.insert(nodeTier,{"Black Ash Branches",44,5,0});
	table.insert(nodeTier,{"Heavy Black Ash Branches",44,5,0});
	table.insert(nodeTier,{"Ilex Branches",44,6,0});
	table.insert(nodeTier,{"Heavy Ilex Branches",44,6,0});
	table.insert(nodeTier,{"Pile of Ilex Wood",44,6,0});
	table.insert(nodeTier,{"Heavy Pile of Ilex Wood",44,6,0});
	table.insert(nodeTier,{"Heavy Birch Branches",44,7,0});
	table.insert(nodeTier,{"Birch Branches",44,7,0});
	table.insert(nodeTier,{"Oak Branches",44,8,0});
	table.insert(nodeTier,{"Heavy Oak Branches",44,8,0});
	table.insert(nodeTier,{"Walnut Branches",44,9,0});
	table.insert(nodeTier,{"Heavy Walnut Branches",44,9,0});
	table.insert(nodeTier,{"Poplar Branches",44,10,0});
	table.insert(nodeTier,{"Heavy Poplar Branches",44,10,0});

-- U20 & 21 nodes -- need FR/DE translations
	table.insert(nodeTier,{"Gnarled Branches",44,10,0});
	table.insert(nodeTier,{"Heavy Gnarled Branches",44,10,0});
	table.insert(nodeTier,{"Gorgoroth Wood",44,11,0});
	table.insert(nodeTier,{"Heavy Gorgoroth Wood",44,11,0});
	table.insert(nodeTier,{"Gorgoroth Branches",44,11,0});
	table.insert(nodeTier,{"Heavy Gorgoroth Branches",44,11,0});
-- U22 nodes
	table.insert(nodeTier,{"Lasgalen Branches",44,11,0});
	table.insert(nodeTier,{"Heavy Lasgalen Branches",44,11,0});
-- U23 nodes
	table.insert(nodeTier,{"Thornholt Branches",44,12,0});
	table.insert(nodeTier,{"Heavy Thornholt Branches",44,12,0});
-- U24
	table.insert(nodeTier,{"Vales Branches",44,12,0});
	table.insert(nodeTier,{"Heavy Vales Branches",44,12,0});
-- U25
	table.insert(nodeTier,{"Mordor Snag Branches",44,13,0});
	table.insert(nodeTier,{"Heavy Mordor Snag Branches",44,13,0});
	table.insert(nodeTier,{"Langflood Branches",44,13,0});
	table.insert(nodeTier,{"Heavy Langflood Branches",44,13,0});
	table.insert(nodeTier,{"Frost-rimed Ilex Branches",44,13,0});
	table.insert(nodeTier,{"Heavy Frost-rimed Ilex Branches",44,13,0});

	table.insert(nodeTier,{"Pile of Black Ash Wood",44,14,0});
	table.insert(nodeTier,{"Heavy Pile of Black Ash Wood",44,14,0});
	table.insert(nodeTier,{"Wind-swept Black Ash Branches",44,14,0});

	-- scholar node
	table.insert(nodeTier,{"Shattered Pitcher",45,1,0});
	table.insert(nodeTier,{"Broken Urn",45,2,0});
	table.insert(nodeTier,{"Antique Vase",45,3,0});
	table.insert(nodeTier,{"Forgotten Text",45,4,0});
	table.insert(nodeTier,{"Ancient Vase",45,5,0});
	table.insert(nodeTier,{"Sage's Locker",45,6,0});
	table.insert(nodeTier,{"Sage's Casket",45,6,0});
	table.insert(nodeTier,{"Banded Coffer",45,7,0});
	table.insert(nodeTier,{"Heavy Banded Coffer",45,7,0});
	table.insert(nodeTier,{"Ornate Cache",45,8,0});
	table.insert(nodeTier,{"Heavy Ornate Cache",45,8,0});
	table.insert(nodeTier,{"Adorned Chest",45,9,0});
	table.insert(nodeTier,{"Heavy Adorned Chest",45,9,0});
	table.insert(nodeTier,{"Lavish Chest",45,10,0});
	table.insert(nodeTier,{"Heavy Lavish Chest",45,10,0});
-- U20 nodes -- need FR/DE translations
	table.insert(nodeTier,{"Lavish Dagorlad Chest",45,10,0});
	table.insert(nodeTier,{"Heavy Lavish Dagorlad Chest",45,10,0});
	table.insert(nodeTier,{"Gorgoroth Artifact Chest",45,11,0});
	table.insert(nodeTier,{"Heavy Gorgoroth Artifact Chest",45,11,0});
-- U22 nodes
	table.insert(nodeTier,{"Dale Artifact Chest",45,11,0});
	table.insert(nodeTier,{"Heavy Dale Artifact Chest",45,11,0});

-- U24
	table.insert(nodeTier,{"Vales Artifact Chest",45,12,0});
	table.insert(nodeTier,{"Heavy Vales Artifact Chest",45,12,0});
-- U25
	table.insert(nodeTier,{"Ithil Artifact Chest",45,13,0});
	table.insert(nodeTier,{"Heavy Ithil Artifact Chest",45,13,0});
	table.insert(nodeTier,{"Runed Coffer",45,13,0});
	table.insert(nodeTier,{"Heavy Runed Coffer",45,13,0});

	table.insert(nodeTier,{"Sage's Coffer",45,14,0});
	table.insert(nodeTier,{"Sage's Repository",45,14,0});

	-- scholar items
	table.insert(nodeTier,{"Yarrow Root",48,1,0});
	table.insert(nodeTier,{"Woad Plant",48,2,0});
--*** need to check tier on Indigo plant
	table.insert(nodeTier,{"Indigo Plant",48,2,0});
-- misc items -- temporarilly use POI icon
	table.insert(nodeTier,{"Rusty Small Chest",5,11,0});
	table.insert(nodeTier,{"Corroded Small Chest",5,11,0});

	-- cook items
	table.insert(nodeTier,{"Cabbage",46,0,0});
	table.insert(nodeTier,{"Green Onion",46,0,0});
	table.insert(nodeTier,{"Stalk of Rhubarb",46,0,0});
	table.insert(nodeTier,{"Bunch of Raspberries",46,0,0});
	table.insert(nodeTier,{"Bunch of Strawberries",46,0,0});
	table.insert(nodeTier,{"Bunch of Blueberries",46,0,0});
	table.insert(nodeTier,{"Bunch of Blackberries",46,0,0});
	table.insert(nodeTier,{"Tater",46,0,0});
	table.insert(nodeTier,{"Golden Shire Tater",46,0,0});
	table.insert(nodeTier,{"Drop of Honey",46,0,0});
	table.insert(nodeTier,{"Drop of Fine Clover Honey",46,0,0});

-- U20 nodes -- need FR/DE translations
	table.insert(nodeTier,{"Cap of Evengleam",46,0,0});

	-- I use the nodeTier mechanism to autodetect the icon type for some of the fixed default items- only applicable to the EN client.
	table.insert(nodeTier,{"Mailbox",26,0,1});
	table.insert(nodeTier,{"Milestone",27,0,1});
	table.insert(nodeTier,{"Camp Site Fire",17,0,1});
	table.insert(nodeTier,{"Mustering Horn",47,0,1});
	table.insert(nodeTier,{"Forge",18,0,1});
	table.insert(nodeTier,{"Superior Forge",18,0,1});
	table.insert(nodeTier,{"Workbench",18,0,1});
	table.insert(nodeTier,{"Superior Workbench",18,0,1});
	table.insert(nodeTier,{"Oven",18,0,1});
	table.insert(nodeTier,{"Superior Oven",18,0,1});
	table.insert(nodeTier,{"Study",18,0,1});
	table.insert(nodeTier,{"Superior Study",18,0,1});

elseif locale=="fr" then
		-- french /dire Garann ;cible
		-- ore
	table.insert(nodeTier,{"D\195\169p\195\180t de cuivre",43,1,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de cuivre riche",43,1,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de fer des galgals",43,2,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de fer riche des galgals",43,2,0});
	table.insert(nodeTier,{"D\195\169p\195\180t d'argent",43,2,0});
	table.insert(nodeTier,{"D\195\169p\195\180t d'argent riche",43,2,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de fer riche",43,3,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de fer abondant",43,3,0});
	table.insert(nodeTier,{"D\195\169p\195\180t d'or",43,3,0});
	table.insert(nodeTier,{"D\195\169p\195\180t d'or riche",43,3,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de fer des nains",43,4,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de fer riche des nains",43,4,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de platine",43,4,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de platine riche",43,4,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de fer ancien",43,5,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de fer riche ancien",43,5,0});
	table.insert(nodeTier,{"D\195\169p\195\180t d'argent ancien",43,5,0});
	table.insert(nodeTier,{"D\195\169p\195\180t d'argent riche ancien",43,5,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de skarn de Khaz\195\162d",43,6,0});
	table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn de Khaz\195\162d",43,6,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de skarn de Calenard",43,7,0});
	table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn de Calenard",43,7,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de skarn du Riddermark",43,8,0});
	table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn du Riddermark",43,8,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de skarn des Eorlingas",43,9,0});
	table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn des Eorlingas",43,9,0});

	table.insert(nodeTier,{"D\195\169p\195\180t de skarn de l'An\195\179rien",43,10,0});
	table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn de l'An\195\179rien",43,10,0});

	table.insert(nodeTier,{"D\195\169p\195\180t de m\195\169tal de Dagorlad",43,10,0});
	table.insert(nodeTier,{"Riche d\195\169p\195\180t de m\195\169tal de Dagorlad",43,10,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de skarn de Gorgoroth",43,11,0});
	table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn de Gorgoroth",43,11,0});

	table.insert(nodeTier,{"D\195\169pot de skarn d'Erebor",43,11,0});
	table.insert(nodeTier,{"Riche d\195\169pot de skarn d'Erebor",43,11,0});

	table.insert(nodeTier,{"D\195\169p\195\180t de skarn d'Ithil",43,13,0});
	table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn d'Ithil",43,13,0});
	table.insert(nodeTier,{"D\195\169p\195\180t de skarn du Long Fleuve",43,13,0});
	table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn du Long Fleuve",43,13,0});
	-- wood
	table.insert(nodeTier,{"Branches de sorbier",44,1,0});
	table.insert(nodeTier,{"Lourdes branches de sorbier",44,1,0});
	table.insert(nodeTier,{"Branches de fr\195\170ne",44,2,0});
	table.insert(nodeTier,{"Lourdes branches de fr\195\170ne",44,2,0});
	table.insert(nodeTier,{"Branches d'if",44,3,0});
	table.insert(nodeTier,{"Lourdes branches d'if",44,3,0});
	table.insert(nodeTier,{"Branches de lebethron",44,4,0});
	table.insert(nodeTier,{"Lourdes branches de lebethron",44,4,0});
	table.insert(nodeTier,{"Branches de fr\195\170ne noir",44,5,0});
	table.insert(nodeTier,{"Lourdes branches de fr\195\170ne noir",44,5,0});
	table.insert(nodeTier,{"Branches d'ilex",44,6,0});
	table.insert(nodeTier,{"Lourdes branches d'ilex",44,6,0});
	table.insert(nodeTier,{"Tas de bois d'ilex",44,6,0});
	table.insert(nodeTier,{"Bois d'ilex lourd",44,6,0});
	table.insert(nodeTier,{"Branches de bouleau",44,7,0});
	table.insert(nodeTier,{"Grandes branches de bouleau",44,7,0}); -- not sure why they went with Grandes in stead of Lourdes
	table.insert(nodeTier,{"Branches de ch\195\168ne",44,8,0});
	table.insert(nodeTier,{"Branches de ch\195\168ne lourdes",44,8,0});
	table.insert(nodeTier,{"Branches de noyer",44,9,0});
	table.insert(nodeTier,{"Lourdes branches de noyer",44,9,0});

	table.insert(nodeTier,{"Branches de peuplier",44,10,0});
	table.insert(nodeTier,{"Lourdes branches de peuplier",44,10,0});
	table.insert(nodeTier,{"Branches torses",44,10,0});
	table.insert(nodeTier,{"Lourdes branches torses",44,10,0});

	table.insert(nodeTier,{"Branche de Gorgoroth",44,11,0});
	table.insert(nodeTier,{"Grandes branches de Gorgoroth",44,11,0});
	table.insert(nodeTier,{"Bois de Gorgoroth",44,11,0});
	table.insert(nodeTier,{"Gros morceaux de bois de Gorgoroth",44,11,0});
	table.insert(nodeTier,{"Branches de Lasgalen",44,11,0});
	table.insert(nodeTier,{"Grandes branches de Lasgalen",44,11,0});

	table.insert(nodeTier,{"Branches tordues du Mordor",44,13,0});
	table.insert(nodeTier,{"Grandes branches tordues du Mordor",44,13,0});
	table.insert(nodeTier,{"Branches du Long Fleuve",44,13,0});
	table.insert(nodeTier,{"Grandes branches du Long Fleuve",44,13,0});
--44,10
	-- scholar
	table.insert(nodeTier,{"Broc cass\195\169",45,1,0});
	table.insert(nodeTier,{"Urne bris\195\169e",45,2,0});
	table.insert(nodeTier,{"Vase antique",45,3,0});
	table.insert(nodeTier,{"Texte oubli\195\169",45,4,0});
	table.insert(nodeTier,{"Vase ancien",45,5,0});
	table.insert(nodeTier,{"Cassette de sage",45,6,0}); -- moria
	table.insert(nodeTier,{"Coffret de sage",45,6,0}); -- moria
	table.insert(nodeTier,{"Coffre cercl\195\169",45,7,0});
	table.insert(nodeTier,{"Coffre cercl\195\169 lourd",45,7,0});

	table.insert(nodeTier,{"Cache d\195\169cor\195\169e",45,8,0});
	table.insert(nodeTier,{"Cache lourde d\195\169cor\195\169e",45,8,0});

	table.insert(nodeTier,{"Coffre consid\195\169rable de Dagorlad",45,8,0});
	table.insert(nodeTier,{"Coffre lourd consid\195\169rable de Dagorlad",45,8,0});
--45,9
	table.insert(nodeTier,{"Coffre orn\195\169",45,9,0});
	table.insert(nodeTier,{"Coffre orn\195\169 lourd",45,9,0});
--45,10
	table.insert(nodeTier,{"Coffre consid\195\169rable",45,10,0});
	table.insert(nodeTier,{"Coffre consid\195\169rable lourd",45,10,0});

	table.insert(nodeTier,{"Coffre rempli d'artefacts de Gorgoroth",45,11,0});
	table.insert(nodeTier,{"Coffre lourde rempli d'artefacts de Gorgoroth",45,11,0});
	table.insert(nodeTier,{"Coffre rempli d'artefacts de Dale",45,11,0});
	table.insert(nodeTier,{"Coffre lourde rempli d'artefacts de Dale",45,11,0});

--	table.insert(nodeTier,{"Coffre rempli d'artefacts du Val",45,12,0});
--	table.insert(nodeTier,{"Coffre lourde rempli d'artefacts du Val",45,12,0});

	table.insert(nodeTier,{"Coffre rempli d'artefacts d'Ithil",45,13,0});
	table.insert(nodeTier,{"Coffre lourde rempli d'artefacts d'Ithil",45,13,0});
	-- scholar items
	table.insert(nodeTier,{"Racine d'achill\195\169e",48,1,0});
	table.insert(nodeTier,{"Pousse de gu\195\168de",48,2,0});
	-- cook
	table.insert(nodeTier,{"Chou",46,0,0});
	table.insert(nodeTier,{"Oignon vert",46,0,0});
	table.insert(nodeTier,{"P\195\169tiole de rhubarbe",46,0,0});
	table.insert(nodeTier,{"Framboises",46,0,0});
	table.insert(nodeTier,{"Fraises",46,0,0});
	table.insert(nodeTier,{"Myrtilles",46,0,0});
	table.insert(nodeTier,{"M\195\187res",46,0,0});
	table.insert(nodeTier,{"Patate",46,0,0});
	table.insert(nodeTier,{"Patate dor\195\169e de la Comt\195\169",46,0,0});
	table.insert(nodeTier,{"Goutte de miel",46,0,0});
	table.insert(nodeTier,{"Goutte de d\195\169licieux miel de tr\195\168fle",46,0,0});
-- misc
	table.insert(nodeTier,{"Petit coffre rouill\195\169",5,0,0});
	table.insert(nodeTier,{"Petit coffre corrod\195\169",5,0,0});

elseif locale=="de" then
	-- german /flstern Garann ;ziel
	-- ore
	table.insert(nodeTier,{"Ader: Kupfer",43,1,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Kupfer",43,1,0});
	table.insert(nodeTier,{"Ader: H\195\188gelgrab-Eisen",43,2,0});
	table.insert(nodeTier,{"Reichhaltige Ader: H\195\188gelgrab-Eisen",43,2,0});
	table.insert(nodeTier,{"Ader: Silber",43,2,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Silber",43,2,0});
	table.insert(nodeTier,{"Ader: Hochwertiges Eisen",43,3,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Hochwertiges Eisen",43,3,0});
	table.insert(nodeTier,{"Ader: Gold",43,3,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Gold",43,3,0});
	table.insert(nodeTier,{"Ader: Zwergeneisen",43,4,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Zwergeneisen",43,4,0});
	table.insert(nodeTier,{"Ader: Platin",43,4,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Platin",43,4,0});
	table.insert(nodeTier,{"Ader: Uraltes Eisen",43,5,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Uraltes Eisen",43,5,0});
	table.insert(nodeTier,{"Ader: Uraltes Silber",43,5,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Uraltes Silber",43,5,0});
	table.insert(nodeTier,{"Ader: Khaz\195\162d-Skarn",43,6,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Khaz\195\162d-Skarn",43,6,0});
	table.insert(nodeTier,{"Ader: Calenard-Skarn",43,7,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Calenard-Skarn",43,7,0});
	table.insert(nodeTier,{"Ader: Riddermark-Skarn",43,8,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Riddermark-Skarn",43,8,0});
	table.insert(nodeTier,{"Ader: Skarn der Eorlingas",43,9,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Skarn der Eorlingas",43,9,0});
	table.insert(nodeTier,{"Ader: An\195\179risches Skarn",43,10,0});
	table.insert(nodeTier,{"Reichhaltige Ader: An\195\179risches Skarn",43,10,0});

	table.insert(nodeTier,{"Ader: Dagorlad-Fragmente",43,10,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Dagorlad-Fragmente",43,10,0});
	table.insert(nodeTier,{"Ader: Gorgoroth-Skarn",43,11,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Gorgoroth-Skarn",43,11,0});
	table.insert(nodeTier,{"Ader: Erebor-Skarn",43,11,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Erebor-Skarn",43,11,0});
	table.insert(nodeTier,{"Ader: Tal-Skarn",43,12,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Tal-Skarn",43,12,0});
	table.insert(nodeTier,{"Ader: Ithil-Skarn",43,13,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Ithil-Skarn",43,13,0});
	table.insert(nodeTier,{"Ader: Langflut-Skarn",43,13,0});
	table.insert(nodeTier,{"Reichhaltige Ader: Langflut-Skarn",43,13,0});
	-- wood
	table.insert(nodeTier,{"Ebereschen-Zweige",44,1,0});
	table.insert(nodeTier,{"Schwere Ebereschen-Zweige",44,1,0});
	table.insert(nodeTier,{"Eschenzweige",44,2,0});
	table.insert(nodeTier,{"Schwere Eschenzweige",44,2,0});
	table.insert(nodeTier,{"Eibenzweige",44,3,0});
	table.insert(nodeTier,{"Schwere Eibenzweige",44,3,0});
	table.insert(nodeTier,{"Lebethron-Zweige",44,4,0});
	table.insert(nodeTier,{"Schwere Lebethron-Zweige",44,4,0});
	table.insert(nodeTier,{"Schwarzeschen-Zweige",44,5,0});
	table.insert(nodeTier,{"Schwere Schwarzeschen-Zweige",44,5,0});
	table.insert(nodeTier,{"Stechpalmen-Zweige",44,6,0});
	table.insert(nodeTier,{"Schwere Stechpalmen-Zweige",44,6,0});
	table.insert(nodeTier,{"Stapel Stechpalmen-Holz",44,6,0});
	table.insert(nodeTier,{"Stapel schweres Stechpalmen-Holz",44,6,0});
	table.insert(nodeTier,{"Birkenzweige",44,7,0});
	table.insert(nodeTier,{"Schwere Birkenzweige",44,7,0});
	table.insert(nodeTier,{"Eichenzweige",44,8,0});
	table.insert(nodeTier,{"Schwere Eichenzweige",44,8,0});
	table.insert(nodeTier,{"Walnusszweige",44,9,0});
	table.insert(nodeTier,{"Schwere Walnusszweige",44,9,0});
	table.insert(nodeTier,{"Pappelzweige",44,10,0});
	table.insert(nodeTier,{"Schwere Pappelzweige",44,10,0});

	table.insert(nodeTier,{"Knorrige \195\132ste",44,10,0});
	table.insert(nodeTier,{"Schwere knorrige \195\132ste",44,10,0});

	table.insert(nodeTier,{"Gorgoroth-Holz",44,11,0});
	table.insert(nodeTier,{"Schweres Gorgoroth-Holz",44,11,0});
	table.insert(nodeTier,{"Gorgoroth-\195\132ste",44,11,0});
	table.insert(nodeTier,{"Schwere Gorgoroth-\195\132ste",44,11,0});
	table.insert(nodeTier,{"Lasgalen-Zweige",44,11,0});
	table.insert(nodeTier,{"Schwere Lasgalen-Zweige",44,11,0});

	table.insert(nodeTier,{"\195\132ste aus den T\195\164lern: \195\132ste aus den T\195\164lern",44,12,0});
	table.insert(nodeTier,{"Schwere \195\132ste aus den T\195\164lern: \195\132ste aus den T\195\164lern",44,12,0});
	table.insert(nodeTier,{"Totholzzweige aus Mordor",44,13,0});
	table.insert(nodeTier,{"Schwere Totholzzweige aus Mordor",44,13,0});
	table.insert(nodeTier,{"Langflut-ste",44,13,0});
	table.insert(nodeTier,{"Schwere Langflut-ste",44,13,0});
	-- scholar node
	table.insert(nodeTier,{"Zerschmetterter Krug",45,1,0});
	table.insert(nodeTier,{"Zerbrochene Urne",45,2,0});
	table.insert(nodeTier,{"Antike Vase",45,3,0});
	table.insert(nodeTier,{"Vergessener Text",45,4,0});
	table.insert(nodeTier,{"Uralte Vase",45,5,0});
	table.insert(nodeTier,{"Schatulle des Weisen",45,6,0}); -- moria
	table.insert(nodeTier,{"Schrank des Weisen",45,6,0}); -- also moria
	table.insert(nodeTier,{"Truhe mit B\195\164ndern",45,7,0});
	table.insert(nodeTier,{"Schwere Truhe mit B\195\164ndern",45,7,0});

	table.insert(nodeTier,{"Verschn\195\182rkelte Truhe",45,8,0});
	table.insert(nodeTier,{"Schwere Verschn\195\182rkelte Truhe",45,8,0}); -- ? need to verify this
--45,9
--Verzierte Truhe
	table.insert(nodeTier,{"Verzierte Truhe",45,9,0});
	table.insert(nodeTier,{"Schwere Verzierte Truhe",45,9,0}); -- ? need to verify this
--45,10
	table.insert(nodeTier,{"Luxuri\195\182se Truhe",45,10,0});
	table.insert(nodeTier,{"Schwere Luxuri\195\182se Truhe",45,10,0}); -- ? need to verify this

	table.insert(nodeTier,{"Luxuri\195\182se Dagorlad-Truhe",45,10,0});
	table.insert(nodeTier,{"Schwere Luxuri\195\182se Dagorlad-Truhe",45,10,0}); -- ? need to verify
	table.insert(nodeTier,{"Gorgoroth-Artefakttruhe",45,11,0});
	table.insert(nodeTier,{"Schwere Gorgoroth-Artefakttruhe",45,11,0});
	table.insert(nodeTier,{"Artefakttruhe aus Thal",45,11,0});
	table.insert(nodeTier,{"Schwere Thal-Artefakttruhe'",45,11,0});

	table.insert(nodeTier,{"Artefakttruhe aus den T\195\164lern",45,12,0});
	table.insert(nodeTier,{"Schwere Artefakttruhe aus den T\195\164lern'",45,12,0});
	table.insert(nodeTier,{"Ithil-Artefakttruhe",45,13,0});
	table.insert(nodeTier,{"Schwere Ithil-Artefakttruhe'",45,13,0});

	-- scholar items
	table.insert(nodeTier,{"Schafgarben-Wurzel",48,1,0});
	table.insert(nodeTier,{"Waidpflanze",48,2,0});
	-- cook
	table.insert(nodeTier,{"Kohlkopf",46,0,0});
	table.insert(nodeTier,{"Fr\195\188hlingszwiebel",46,0,0});
	table.insert(nodeTier,{"Rhabarberst\195\164ngel",46,0,0});
	table.insert(nodeTier,{"Handvoll Himbeeren",46,0,0});
	table.insert(nodeTier,{"Handvoll Erdbeeren",46,0,0});
	table.insert(nodeTier,{"Handvoll Blaubeeren",46,0,0});
	table.insert(nodeTier,{"Handvoll Brombeeren",46,0,0});
	table.insert(nodeTier,{"Kartoffel",46,0,0});
	table.insert(nodeTier,{"Goldene Auenland-Kartoffel",46,0,0});
	table.insert(nodeTier,{"Tropfen Honig",46,0,0});
	table.insert(nodeTier,{"Tropfen edler Kleehonig",46,0,0});
	table.insert(nodeTier,{"Abendrotkppchen",46,0,0});
-- misc

	table.insert(nodeTier,{"Rostige kleine Truhe",5,11,0});
	table.insert(nodeTier,{"Korrodierte kleine Truhe'",5,11,0});

end
