importPath=string.gsub(getfenv(1)._.Name,"%.OptionsPanel","").."."
import (importPath.."ColorPicker")

-- need to create the options window

-- need to add a "show options" button to the plugin manager

	optionsWindow=Turbine.UI.Lotro.Window()
	optionsWindow:SetSize(530,654);
	optionsWindow:SetZOrder(2);

	optionsPanel=Turbine.UI.Control();
	optionsPanel:SetParent(optionsWindow);
	optionsPanel:SetSize(optionsWindow:GetWidth()-20,optionsWindow:GetHeight()-70);
	optionsPanel:SetPosition(10,45)

	optionsViewPane=Turbine.UI.Control();
	optionsViewPane:SetParent(optionsPanel);
	optionsViewPane:SetSize(optionsPanel:GetWidth()-10,optionsPanel:GetHeight()-35)

	optionsCanvas = Turbine.UI.Control()
	optionsCanvas:SetParent(optionsViewPane);
	optionsCanvas:SetSize(500,882);

	optionsCanvas.HadErrors=false;
	optionsCanvas:SetBackColor(Settings.backColor);

	optionsCanvas.OptionsCaption=Turbine.UI.Label();
	optionsCanvas.OptionsCaption:SetParent(optionsCanvas);
	optionsCanvas.OptionsCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	optionsCanvas.OptionsCaption:SetForeColor(Settings.headingsColor);
	optionsCanvas.OptionsCaption:SetSize(optionsCanvas:GetWidth(),20);
	optionsCanvas.OptionsCaption:SetPosition(0,0);
	optionsCanvas.OptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	optionsCanvas.OptionsCaption:SetText(Resource[Settings.language][4]);

	optionsCanvas.OptionsSep=Turbine.UI.Control();
	optionsCanvas.OptionsSep:SetParent(optionsCanvas);
	optionsCanvas.OptionsSep:SetBackColor(Settings.headingsColor);
	optionsCanvas.OptionsSep:SetSize(optionsCanvas:GetWidth(),1);
	optionsCanvas.OptionsSep:SetPosition(0,optionsCanvas.OptionsCaption:GetTop()+optionsCanvas.OptionsCaption:GetHeight()+1);

	optionsCanvas.LanguageCaption=Turbine.UI.Label();
	optionsCanvas.LanguageCaption:SetParent(optionsCanvas);
	optionsCanvas.LanguageCaption:SetPosition(10,optionsCanvas.OptionsCaption:GetTop()+optionsCanvas.OptionsCaption:GetHeight()+9);
	optionsCanvas.LanguageCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.LanguageCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.LanguageCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.LanguageCaption:SetText(Resource[Settings.language][5]..":");

	optionsCanvas.LanguageList=DropDownList();
	optionsCanvas.LanguageList:SetParent(optionsCanvas);
	optionsCanvas.LanguageList:SetPosition(optionsCanvas.LanguageCaption:GetLeft()+optionsCanvas.LanguageCaption:GetWidth()+2,optionsCanvas.LanguageCaption.GetTop()-3);
	optionsCanvas.LanguageList:SetSize(optionsCanvas:GetWidth()-(optionsCanvas.LanguageCaption:GetWidth()+optionsCanvas.LanguageCaption:GetLeft())-65,20);
	optionsCanvas.LanguageList:SetBorderColor(Settings.trimColor);
	optionsCanvas.LanguageList:SetBackColor(Settings.backColor);
	optionsCanvas.LanguageList:SetCurrentBackColor(Settings.backColor);
	optionsCanvas.LanguageList:SetDropRows(5);

	optionsCanvas.LanguageList:AddItem(Resource[Settings.language][401],0);
	for tmpLanguage in pairs(Resource) do
		optionsCanvas.LanguageList:AddItem(Resource[tmpLanguage][1],tmpLanguage);
	end

	optionsCanvas.LanguageList.SelectedIndexChanged = function ()
		local tmpLanguage=optionsCanvas.LanguageList:GetValue()
		if tmpLanguage==0 then
			if locale=="de" then
				tmpLanguage=3
			elseif locale=="fr" then
				tmpLanguage=2
			elseif locale=="ru" then
				tmpLanguage=4
			else
				tmpLanguage=1
			end
		end
		optionsCanvas:SetLanguage(tmpLanguage);
	end
	optionsCanvas.LanguageList:SetTextColor(Settings.listTextColor);

	optionsCanvas.WorldCaption=Turbine.UI.Label();
	optionsCanvas.WorldCaption:SetParent(optionsCanvas);
	optionsCanvas.WorldCaption:SetPosition(10,optionsCanvas.LanguageCaption:GetTop()+optionsCanvas.LanguageCaption:GetHeight()+9);
	optionsCanvas.WorldCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.WorldCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.WorldCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.WorldCaption:SetText(Resource[Settings.language][149]..":");

	optionsCanvas.WorldList=DropDownList();
	optionsCanvas.WorldList:SetParent(optionsCanvas);
	optionsCanvas.WorldList:SetPosition(optionsCanvas.WorldCaption:GetLeft()+optionsCanvas.WorldCaption:GetWidth()+2,optionsCanvas.WorldCaption.GetTop()-3);
	optionsCanvas.WorldList:SetSize(optionsCanvas:GetWidth()-(optionsCanvas.WorldCaption:GetWidth()+optionsCanvas.WorldCaption:GetLeft())-65,20);
	optionsCanvas.WorldList:SetBorderColor(Settings.trimColor);
	optionsCanvas.WorldList:SetBackColor(Settings.backColor);
	optionsCanvas.WorldList:SetCurrentBackColor(Settings.backColor);
	optionsCanvas.WorldList:SetDropRows(5);

	optionsCanvas.WorldList:AddItem("Arkenstone","Arkenstone"); -- ok 1
	optionsCanvas.WorldList:AddItem("Brandywine","Brandywine"); -- ok 2
	optionsCanvas.WorldList:AddItem("Crickhollow","Crickhollow"); -- ok 3
	optionsCanvas.WorldList:AddItem("Dwarrowdelf CLOSED","Dwarrowdelf");
	optionsCanvas.WorldList:AddItem("Elendilmir CLOSED","Elendilmir");
	optionsCanvas.WorldList:AddItem("Firefoot CLOSED","Firefoot");
	optionsCanvas.WorldList:AddItem("Gladden","Gladden"); -- ok 7
	optionsCanvas.WorldList:AddItem("Imladris CLOSED","Imladris");
	optionsCanvas.WorldList:AddItem("Landroval","Landroval"); -- ok 9
	optionsCanvas.WorldList:AddItem("Meneldor CLOSED","Meneldor");
	optionsCanvas.WorldList:AddItem("Nimrodel CLOSED","Nimrodel");
	optionsCanvas.WorldList:AddItem("Riddermark CLOSED","Riddermark");
	optionsCanvas.WorldList:AddItem("Silverlode CLOSED","Silverlode");
	optionsCanvas.WorldList:AddItem("Vilya CLOSED","Vilya");
	optionsCanvas.WorldList:AddItem("Windfola CLOSED","Windfola");
	optionsCanvas.WorldList:AddItem("[DE] Anduin CLOSED","_DE_Anduin");
	optionsCanvas.WorldList:AddItem("[DE] Gwaihir","_DE_Gwaihir"); -- ok 17
	optionsCanvas.WorldList:AddItem("[DE] Maiar CLOSED","_DE_Maiar");
	optionsCanvas.WorldList:AddItem("[DE] Morthond CLOSED","_DE_Morthond");
	optionsCanvas.WorldList:AddItem("[DE] Vanyar CLOSED","_DE_Vanyar");
	optionsCanvas.WorldList:AddItem("[DE-RP] Belegaer","_DE_RP_Belegaer"); -- ok 21
	optionsCanvas.WorldList:AddItem("[EN] Eldar CLOSED","_EN_Eldar");
	optionsCanvas.WorldList:AddItem("[EN] Evernight","_EN_Evernight"); -- ok 23
	optionsCanvas.WorldList:AddItem("[EN] Gilrain CLOSED","_EN_Gilrain");
	optionsCanvas.WorldList:AddItem("[EN] Snowbourn CLOSED","_EN_Snowbourn");
	optionsCanvas.WorldList:AddItem("[EN] Withywindle CLOSED","_EN_Withywindle");
	optionsCanvas.WorldList:AddItem("[EN-RP] Laurelin","_EN_RP_Laurelin"); -- ok 27
	optionsCanvas.WorldList:AddItem("[FR] Sirannon","_FR_Sirannon"); -- ok 28
	optionsCanvas.WorldList:AddItem("[FR-RP] Estel CLOSED","_FR_RP_Estel");
	optionsCanvas.WorldList:AddItem("Anor LEGENDARY VIP","Anor"); -- ok 30
	optionsCanvas.WorldList:AddItem("Ithil LEGENDARY VIP","Ithil"); -- ok 31
-- now hide the closed worlds -- we do this so that old users can still load with their world selected but won't see the selection (they need to choose a new world) and the hidden entries can't be selected anymore
	optionsCanvas.WorldList:HideEntry(4);
	optionsCanvas.WorldList:HideEntry(5);
	optionsCanvas.WorldList:HideEntry(6);
	optionsCanvas.WorldList:HideEntry(8);
	optionsCanvas.WorldList:HideEntry(10);
	optionsCanvas.WorldList:HideEntry(11);
	optionsCanvas.WorldList:HideEntry(12);
	optionsCanvas.WorldList:HideEntry(13);
	optionsCanvas.WorldList:HideEntry(14);
	optionsCanvas.WorldList:HideEntry(15);
	optionsCanvas.WorldList:HideEntry(16);
	optionsCanvas.WorldList:HideEntry(18);
	optionsCanvas.WorldList:HideEntry(19);
	optionsCanvas.WorldList:HideEntry(20);
	optionsCanvas.WorldList:HideEntry(22);
	optionsCanvas.WorldList:HideEntry(24);
	optionsCanvas.WorldList:HideEntry(25);
	optionsCanvas.WorldList:HideEntry(26);
	optionsCanvas.WorldList:HideEntry(29);

	optionsCanvas.WorldList:SetTextColor(Settings.listTextColor);

	optionsCanvas.DefaultMapCaption=Turbine.UI.Label();
	optionsCanvas.DefaultMapCaption:SetParent(optionsCanvas);
	optionsCanvas.DefaultMapCaption:SetPosition(10,optionsCanvas.WorldCaption:GetTop()+optionsCanvas.WorldCaption:GetHeight()+9);
	optionsCanvas.DefaultMapCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.DefaultMapCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.DefaultMapCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.DefaultMapCaption:SetText(Resource[Settings.language][200]..":");

	optionsCanvas.DefaultMapList=DropDownList();
	optionsCanvas.DefaultMapList:SetParent(optionsCanvas);
	optionsCanvas.DefaultMapList:SetPosition(optionsCanvas.DefaultMapCaption:GetLeft()+optionsCanvas.DefaultMapCaption:GetWidth()+2,optionsCanvas.DefaultMapCaption.GetTop()-3);
	optionsCanvas.DefaultMapList:SetSize(optionsCanvas:GetWidth()-(optionsCanvas.DefaultMapCaption:GetWidth()+optionsCanvas.DefaultMapCaption:GetLeft())-65,20);
	optionsCanvas.DefaultMapList:SetBorderColor(Settings.trimColor);
	optionsCanvas.DefaultMapList:SetBackColor(Settings.backColor);
	optionsCanvas.DefaultMapList:SetCurrentBackColor(Settings.backColor);
	optionsCanvas.DefaultMapList:SetDropRows(5);

	local tmpIndex;

	optionsCanvas.DefaultMapList:AddItem(Resource[Settings.language][227],-2)
	for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
		if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue]~=nil and mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue][11]==1 then
			optionsCanvas.DefaultMapList:AddItem(mapWindow.MapSelect.ListData:GetItem(tmpIndex):GetText(),mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue)
		end
	end
	optionsCanvas.DefaultMapList:SetTextColor(Settings.listTextColor);

-- trim color
	optionsCanvas.TrimCaption=Turbine.UI.Label();
	optionsCanvas.TrimCaption:SetParent(optionsCanvas);
	optionsCanvas.TrimCaption:SetPosition(10,optionsCanvas.DefaultMapCaption:GetTop()+optionsCanvas.DefaultMapCaption:GetHeight()+9);
	optionsCanvas.TrimCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.TrimCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.TrimCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.TrimCaption:SetText(Resource[Settings.language][6]..":");
	optionsCanvas.TrimColor=ColorPicker();
	optionsCanvas.TrimColor:SetParent(optionsCanvas);
	optionsCanvas.TrimColor:SetPosition(optionsCanvas.TrimCaption:GetLeft()+optionsCanvas.TrimCaption:GetWidth()+5,optionsCanvas.TrimCaption:GetTop()-1);
	optionsCanvas.TrimColor:SetTrimColor(Settings.trimColor);
	optionsCanvas.TrimColor:SetColor(Settings.trimColor);
	optionsCanvas.TrimColor.ColorChanged=function()
		optionsCanvas:SetTrimColor(optionsCanvas.TrimColor:GetColor());
	end

	optionsCanvas.BackCaption=Turbine.UI.Label();
	optionsCanvas.BackCaption:SetParent(optionsCanvas);
	optionsCanvas.BackCaption:SetPosition(10,optionsCanvas.TrimColor:GetTop()+optionsCanvas.TrimColor:GetHeight()+9);
	optionsCanvas.BackCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.BackCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.BackCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.BackCaption:SetText(Resource[Settings.language][7]..":");
	optionsCanvas.BackColor=ColorPicker();
	optionsCanvas.BackColor:SetParent(optionsCanvas);
	optionsCanvas.BackColor:SetPosition(optionsCanvas.BackCaption:GetLeft()+optionsCanvas.BackCaption:GetWidth()+5,optionsCanvas.BackCaption:GetTop()-1);
	optionsCanvas.BackColor:SetTrimColor(Settings.trimColor);
	optionsCanvas.BackColor:SetColor(Settings.backColor);
	optionsCanvas.BackColor.ColorChanged=function()
		optionsCanvas:SetBackColor(optionsCanvas.BackColor:GetColor());
	end

	optionsCanvas.FontCaption=Turbine.UI.Label();
	optionsCanvas.FontCaption:SetParent(optionsCanvas);
	optionsCanvas.FontCaption:SetPosition(10,optionsCanvas.BackColor:GetTop()+optionsCanvas.BackColor:GetHeight()+9);
	optionsCanvas.FontCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.FontCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.FontCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.FontCaption:SetText(Resource[Settings.language][8]..":"); --"Font Color:");
	optionsCanvas.FontColor=ColorPicker();
	optionsCanvas.FontColor:SetParent(optionsCanvas);
	optionsCanvas.FontColor:SetPosition(optionsCanvas.FontCaption:GetLeft()+optionsCanvas.FontCaption:GetWidth()+5,optionsCanvas.FontCaption:GetTop()-1);
	optionsCanvas.FontColor:SetTrimColor(Settings.trimColor);
	optionsCanvas.FontColor:SetColor(Settings.fontColor);
	optionsCanvas.FontColor.ColorChanged=function()
		optionsCanvas:SetFontColor(optionsCanvas.FontColor:GetColor());
	end

	optionsCanvas.HeadingsCaption=Turbine.UI.Label();
	optionsCanvas.HeadingsCaption:SetParent(optionsCanvas);
	optionsCanvas.HeadingsCaption:SetPosition(10,optionsCanvas.FontColor:GetTop()+optionsCanvas.FontColor:GetHeight()+9);
	optionsCanvas.HeadingsCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.HeadingsCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.HeadingsCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.HeadingsCaption:SetText(Resource[Settings.language][15]..":");
	optionsCanvas.HeadingsColor=ColorPicker();
	optionsCanvas.HeadingsColor:SetParent(optionsCanvas);
	optionsCanvas.HeadingsColor:SetPosition(optionsCanvas.HeadingsCaption:GetLeft()+optionsCanvas.HeadingsCaption:GetWidth()+5,optionsCanvas.HeadingsCaption:GetTop()-1);
	optionsCanvas.HeadingsColor:SetTrimColor(Settings.trimColor);
	optionsCanvas.HeadingsColor:SetColor(Settings.headingsColor);
	optionsCanvas.HeadingsColor.ColorChanged=function()
		optionsCanvas:SetHeadingsColor(optionsCanvas.HeadingsColor:GetColor());
	end

	optionsCanvas.ListTextCaption=Turbine.UI.Label();
	optionsCanvas.ListTextCaption:SetParent(optionsCanvas);
	optionsCanvas.ListTextCaption:SetPosition(10,optionsCanvas.HeadingsColor:GetTop()+optionsCanvas.HeadingsColor:GetHeight()+9);
	optionsCanvas.ListTextCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.ListTextCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.ListTextCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.ListTextCaption:SetText(Resource[Settings.language][16]..":");
	optionsCanvas.ListTextColor=ColorPicker();
	optionsCanvas.ListTextColor:SetParent(optionsCanvas);
	optionsCanvas.ListTextColor:SetPosition(optionsCanvas.ListTextCaption:GetLeft()+optionsCanvas.ListTextCaption:GetWidth()+5,optionsCanvas.ListTextCaption:GetTop()-1);
	optionsCanvas.ListTextColor:SetTrimColor(Settings.trimColor);
	optionsCanvas.ListTextColor:SetColor(Settings.listTextColor);
	optionsCanvas.ListTextColor.ColorChanged=function()
		optionsCanvas:SetListTextColor(optionsCanvas.ListTextColor:GetColor());
	end

	optionsCanvas.ResetColors=Turbine.UI.Lotro.Button();
	optionsCanvas.ResetColors:SetParent(optionsCanvas);
	optionsCanvas.ResetColors:SetSize(160,20);
	optionsCanvas.ResetColors:SetPosition((optionsCanvas:GetWidth()-optionsCanvas.ResetColors:GetWidth())/2,optionsCanvas.ListTextColor:GetTop()+optionsCanvas.ListTextColor:GetHeight()+9);
	optionsCanvas.ResetColors:SetText(Resource[Settings.language][9]);
	optionsCanvas.ResetColors.Click=function()
		Settings.trimColor=Turbine.UI.Color(.2,.5,.9);
		Settings.fontColor=Turbine.UI.Color(1,.9,.5);
		Settings.backColor=Turbine.UI.Color(.05,.05,.05);
		Settings.headingsColor=Turbine.UI.Color(1,1,1);
		Settings.listTextColor=Turbine.UI.Color(1,1,1);
		optionsCanvas.TrimColor:SetColor(Settings.trimColor);
		optionsCanvas.FontColor:SetColor(Settings.fontColor);
		optionsCanvas.BackColor:SetColor(Settings.backColor);
		optionsCanvas.HeadingsColor:SetColor(Settings.headingsColor);
		optionsCanvas.ListTextColor:SetColor(Settings.listTextColor);
	end

	optionsCanvas.OpacityCaption=Turbine.UI.Label();
	optionsCanvas.OpacityCaption:SetParent(optionsCanvas);
	optionsCanvas.OpacityCaption:SetPosition(10,optionsCanvas.ResetColors:GetTop()+optionsCanvas.ResetColors:GetHeight()+9);
	optionsCanvas.OpacityCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.OpacityCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.OpacityCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.OpacityCaption:SetText(Resource[Settings.language][71]..":");
	optionsCanvas.OpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	optionsCanvas.OpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	optionsCanvas.OpacityScrollbar:SetParent(optionsCanvas)
	optionsCanvas.OpacityScrollbar:SetPosition(optionsCanvas.OpacityCaption:GetLeft()+optionsCanvas.OpacityCaption:GetWidth()+5,optionsCanvas.OpacityCaption:GetTop());
	optionsCanvas.OpacityScrollbar:SetSize(optionsCanvas:GetWidth()-optionsCanvas.OpacityCaption:GetWidth()-optionsCanvas.OpacityCaption:GetLeft()-15,10);
	optionsCanvas.OpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	optionsCanvas.OpacityScrollbar:SetMinimum(0);
	optionsCanvas.OpacityScrollbar:SetMaximum(100);
	optionsCanvas.OpacityScrollbar.OriginalValue=100;
	optionsCanvas.OpacityScrollbar.ValueChanged=function()
		mapWindow.Map:SetOpacity(optionsCanvas.OpacityScrollbar:GetValue()/100);
	end


	optionsCanvas.MapCaption=Turbine.UI.Label();
	optionsCanvas.MapCaption:SetParent(optionsCanvas);
	optionsCanvas.MapCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	optionsCanvas.MapCaption:SetForeColor(Settings.headingsColor);
	optionsCanvas.MapCaption:SetSize(optionsCanvas:GetWidth(),20);
	optionsCanvas.MapCaption:SetPosition(0,optionsCanvas.OpacityCaption:GetTop()+30);
	optionsCanvas.MapCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	optionsCanvas.MapCaption:SetText(Resource[Settings.language][279]);

	optionsCanvas.MapSep=Turbine.UI.Control();
	optionsCanvas.MapSep:SetParent(optionsCanvas);
	optionsCanvas.MapSep:SetBackColor(Settings.headingsColor);
	optionsCanvas.MapSep:SetSize(optionsCanvas:GetWidth(),1);
	optionsCanvas.MapSep:SetPosition(0,optionsCanvas.MapCaption:GetTop()+optionsCanvas.MapCaption:GetHeight()+1);

	optionsCanvas.MapLeftCaption=Turbine.UI.Label();
	optionsCanvas.MapLeftCaption:SetParent(optionsCanvas);
	optionsCanvas.MapLeftCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.MapLeftCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.MapLeftCaption:SetSize(80,20);
	optionsCanvas.MapLeftCaption:SetPosition(10,optionsCanvas.MapCaption:GetTop()+optionsCanvas.MapCaption:GetHeight()+9);
	optionsCanvas.MapLeftCaption:SetText(Resource[Settings.language][281]..":")

	optionsCanvas.MapLeftValue=Turbine.UI.Lotro.TextBox();
	optionsCanvas.MapLeftValue:SetParent(optionsCanvas);
	optionsCanvas.MapLeftValue:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.MapLeftValue:SetForeColor(Settings.fontColor);
	optionsCanvas.MapLeftValue:SetSize(80,20);
	optionsCanvas.MapLeftValue:SetPosition(optionsCanvas.MapLeftCaption:GetLeft()+optionsCanvas.MapLeftCaption:GetWidth()+5,optionsCanvas.MapLeftCaption:GetTop());
	optionsCanvas.MapLeftValue:SetText(tostring(mapWindow:GetLeft()))

	optionsCanvas.MapTopCaption=Turbine.UI.Label();
	optionsCanvas.MapTopCaption:SetParent(optionsCanvas);
	optionsCanvas.MapTopCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.MapTopCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.MapTopCaption:SetSize(80,20);
	optionsCanvas.MapTopCaption:SetPosition(optionsCanvas:GetWidth()/2,optionsCanvas.MapLeftCaption:GetTop());
	optionsCanvas.MapTopCaption:SetText(Resource[Settings.language][282]..":")

	optionsCanvas.MapTopValue=Turbine.UI.Lotro.TextBox();
	optionsCanvas.MapTopValue:SetParent(optionsCanvas);
	optionsCanvas.MapTopValue:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.MapTopValue:SetForeColor(Settings.fontColor);
	optionsCanvas.MapTopValue:SetSize(80,20);
	optionsCanvas.MapTopValue:SetPosition(optionsCanvas.MapTopCaption:GetLeft()+optionsCanvas.MapTopCaption:GetWidth()+5,optionsCanvas.MapTopCaption:GetTop());
	optionsCanvas.MapTopValue:SetText(tostring(mapWindow:GetTop()))

	optionsCanvas.MapWidthCaption=Turbine.UI.Label();
	optionsCanvas.MapWidthCaption:SetParent(optionsCanvas);
	optionsCanvas.MapWidthCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.MapWidthCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.MapWidthCaption:SetSize(80,20);
	optionsCanvas.MapWidthCaption:SetPosition(10,optionsCanvas.MapLeftCaption:GetTop()+optionsCanvas.MapLeftCaption:GetHeight()+4);
	optionsCanvas.MapWidthCaption:SetText(Resource[Settings.language][283]..":")

	optionsCanvas.MapWidthValue=Turbine.UI.Lotro.TextBox();
	optionsCanvas.MapWidthValue:SetParent(optionsCanvas);
	optionsCanvas.MapWidthValue:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.MapWidthValue:SetForeColor(Settings.fontColor);
	optionsCanvas.MapWidthValue:SetSize(80,20);
	optionsCanvas.MapWidthValue:SetPosition(optionsCanvas.MapWidthCaption:GetLeft()+optionsCanvas.MapWidthCaption:GetWidth()+5,optionsCanvas.MapWidthCaption:GetTop());
	optionsCanvas.MapWidthValue:SetText(tostring(mapWindow:GetWidth()))

	optionsCanvas.MapHeightCaption=Turbine.UI.Label();
	optionsCanvas.MapHeightCaption:SetParent(optionsCanvas);
	optionsCanvas.MapHeightCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.MapHeightCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.MapHeightCaption:SetSize(80,20);
	optionsCanvas.MapHeightCaption:SetPosition(optionsCanvas:GetWidth()/2,optionsCanvas.MapWidthCaption:GetTop());
	optionsCanvas.MapHeightCaption:SetText(Resource[Settings.language][284]..":")

	optionsCanvas.MapHeightValue=Turbine.UI.Lotro.TextBox();
	optionsCanvas.MapHeightValue:SetParent(optionsCanvas);
	optionsCanvas.MapHeightValue:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.MapHeightValue:SetForeColor(Settings.fontColor);
	optionsCanvas.MapHeightValue:SetSize(80,20);
	optionsCanvas.MapHeightValue:SetPosition(optionsCanvas.MapHeightCaption:GetLeft()+optionsCanvas.MapHeightCaption:GetWidth()+5,optionsCanvas.MapHeightCaption:GetTop());
	optionsCanvas.MapHeightValue:SetText(tostring(mapWindow:GetHeight()))
-- lock aspect
	optionsCanvas.LockAspectCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.LockAspectCB:SetParent(optionsCanvas);
	optionsCanvas.LockAspectCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.LockAspectCB:SetForeColor(Settings.fontColor);
	optionsCanvas.LockAspectCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.LockAspectCB:SetPosition(10,optionsCanvas.MapHeightCaption:GetTop()+optionsCanvas.MapHeightCaption:GetHeight()+4);
	optionsCanvas.LockAspectCB:SetText(Resource[Settings.language][17]);
-- Load Minimized
	optionsCanvas.LoadMinimizedCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.LoadMinimizedCB:SetParent(optionsCanvas);
	optionsCanvas.LoadMinimizedCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.LoadMinimizedCB:SetForeColor(Settings.fontColor);
	optionsCanvas.LoadMinimizedCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.LoadMinimizedCB:SetPosition(10,optionsCanvas.LockAspectCB:GetTop()+optionsCanvas.LockAspectCB:GetHeight()+4);
	optionsCanvas.LoadMinimizedCB:SetText(Resource[Settings.language][17]);

	optionsCanvas.IconCaption=Turbine.UI.Label();
	optionsCanvas.IconCaption:SetParent(optionsCanvas);
	optionsCanvas.IconCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	optionsCanvas.IconCaption:SetForeColor(Settings.headingsColor);
	optionsCanvas.IconCaption:SetSize(optionsCanvas:GetWidth(),20);
	optionsCanvas.IconCaption:SetPosition(0,optionsCanvas.LoadMinimizedCB:GetTop()+30);
	optionsCanvas.IconCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	optionsCanvas.IconCaption:SetText(Resource[Settings.language][280]);

	optionsCanvas.IconSep=Turbine.UI.Control();
	optionsCanvas.IconSep:SetParent(optionsCanvas);
	optionsCanvas.IconSep:SetBackColor(Settings.headingsColor);
	optionsCanvas.IconSep:SetSize(optionsCanvas:GetWidth(),1);
	optionsCanvas.IconSep:SetPosition(0,optionsCanvas.IconCaption:GetTop()+optionsCanvas.IconCaption:GetHeight()+1);

	optionsCanvas.IconLeftCaption=Turbine.UI.Label();
	optionsCanvas.IconLeftCaption:SetParent(optionsCanvas);
	optionsCanvas.IconLeftCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.IconLeftCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.IconLeftCaption:SetSize(80,20);
	optionsCanvas.IconLeftCaption:SetPosition(10,optionsCanvas.IconCaption:GetTop()+optionsCanvas.IconCaption:GetHeight()+9);
	optionsCanvas.IconLeftCaption:SetText(Resource[Settings.language][281]..":")

	optionsCanvas.IconLeftValue=Turbine.UI.Lotro.TextBox();
	optionsCanvas.IconLeftValue:SetParent(optionsCanvas);
	optionsCanvas.IconLeftValue:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.IconLeftValue:SetForeColor(Settings.fontColor);
	optionsCanvas.IconLeftValue:SetSize(80,20);
	optionsCanvas.IconLeftValue:SetPosition(optionsCanvas.IconLeftCaption:GetLeft()+optionsCanvas.IconLeftCaption:GetWidth()+5,optionsCanvas.IconLeftCaption:GetTop());
	optionsCanvas.IconLeftValue:SetText(tostring(minWindow:GetLeft()))

	optionsCanvas.IconTopCaption=Turbine.UI.Label();
	optionsCanvas.IconTopCaption:SetParent(optionsCanvas);
	optionsCanvas.IconTopCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.IconTopCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.IconTopCaption:SetSize(80,20);
	optionsCanvas.IconTopCaption:SetPosition(optionsCanvas:GetWidth()/2,optionsCanvas.IconLeftCaption:GetTop());
	optionsCanvas.IconTopCaption:SetText(Resource[Settings.language][282]..":")

	optionsCanvas.IconTopValue=Turbine.UI.Lotro.TextBox();
	optionsCanvas.IconTopValue:SetParent(optionsCanvas);
	optionsCanvas.IconTopValue:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.IconTopValue:SetForeColor(Settings.fontColor);
	optionsCanvas.IconTopValue:SetSize(80,20);
	optionsCanvas.IconTopValue:SetPosition(optionsCanvas.IconTopCaption:GetLeft()+optionsCanvas.IconTopCaption:GetWidth()+5,optionsCanvas.IconTopCaption:GetTop());
	optionsCanvas.IconTopValue:SetText(tostring(minWindow:GetTop()))

-- Show Icon when Minimized
	optionsCanvas.ShowIconWhenMinimizedCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.ShowIconWhenMinimizedCB:SetParent(optionsCanvas);
	optionsCanvas.ShowIconWhenMinimizedCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.ShowIconWhenMinimizedCB:SetForeColor(Settings.fontColor);
	optionsCanvas.ShowIconWhenMinimizedCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.ShowIconWhenMinimizedCB:SetPosition(10,optionsCanvas.IconLeftCaption:GetTop()+optionsCanvas.IconLeftCaption:GetHeight()+4);
	optionsCanvas.ShowIconWhenMinimizedCB:SetText(Resource[Settings.language][18]);

-- Use 16x16 Icon
	optionsCanvas.UseMiniIconCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.UseMiniIconCB:SetParent(optionsCanvas);
	optionsCanvas.UseMiniIconCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.UseMiniIconCB:SetForeColor(Settings.fontColor);
	optionsCanvas.UseMiniIconCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.UseMiniIconCB:SetPosition(10,optionsCanvas.ShowIconWhenMinimizedCB:GetTop()+optionsCanvas.ShowIconWhenMinimizedCB:GetHeight()+4);
	optionsCanvas.UseMiniIconCB:SetText(Resource[Settings.language][201]);

-- Mini Icon is opaque
	optionsCanvas.MiniIconOpaqueCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.MiniIconOpaqueCB:SetParent(optionsCanvas);
	optionsCanvas.MiniIconOpaqueCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.MiniIconOpaqueCB:SetForeColor(Settings.fontColor);
	optionsCanvas.MiniIconOpaqueCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.MiniIconOpaqueCB:SetPosition(30,optionsCanvas.UseMiniIconCB:GetTop()+optionsCanvas.UseMiniIconCB:GetHeight()+4);
	optionsCanvas.MiniIconOpaqueCB:SetText(Resource[Settings.language][202]);

	optionsCanvas.AnnotCaption=Turbine.UI.Label();
	optionsCanvas.AnnotCaption:SetParent(optionsCanvas);
	optionsCanvas.AnnotCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	optionsCanvas.AnnotCaption:SetForeColor(Settings.headingsColor);
	optionsCanvas.AnnotCaption:SetSize(optionsCanvas:GetWidth(),20);
	optionsCanvas.AnnotCaption:SetPosition(0,optionsCanvas.MiniIconOpaqueCB:GetTop()+30);
	optionsCanvas.AnnotCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	optionsCanvas.AnnotCaption:SetText(Resource[Settings.language][285]);

	optionsCanvas.AnnotSep=Turbine.UI.Control();
	optionsCanvas.AnnotSep:SetParent(optionsCanvas);
	optionsCanvas.AnnotSep:SetBackColor(Settings.headingsColor);
	optionsCanvas.AnnotSep:SetSize(optionsCanvas:GetWidth(),1);
	optionsCanvas.AnnotSep:SetPosition(0,optionsCanvas.AnnotCaption:GetTop()+optionsCanvas.AnnotCaption:GetHeight()+1);

	optionsCanvas.AnnotLeftCaption=Turbine.UI.Label();
	optionsCanvas.AnnotLeftCaption:SetParent(optionsCanvas);
	optionsCanvas.AnnotLeftCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.AnnotLeftCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.AnnotLeftCaption:SetSize(80,20);
	optionsCanvas.AnnotLeftCaption:SetPosition(10,optionsCanvas.AnnotCaption:GetTop()+optionsCanvas.AnnotCaption:GetHeight()+9);
	optionsCanvas.AnnotLeftCaption:SetText(Resource[Settings.language][281]..":")

	optionsCanvas.AnnotLeftValue=Turbine.UI.Lotro.TextBox();
	optionsCanvas.AnnotLeftValue:SetParent(optionsCanvas);
	optionsCanvas.AnnotLeftValue:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.AnnotLeftValue:SetForeColor(Settings.fontColor);
	optionsCanvas.AnnotLeftValue:SetSize(80,20);
	optionsCanvas.AnnotLeftValue:SetPosition(optionsCanvas.AnnotLeftCaption:GetLeft()+optionsCanvas.AnnotLeftCaption:GetWidth()+5,optionsCanvas.AnnotLeftCaption:GetTop());
	optionsCanvas.AnnotLeftValue:SetText(tostring(quickWindow:GetLeft()))

	optionsCanvas.AnnotTopCaption=Turbine.UI.Label();
	optionsCanvas.AnnotTopCaption:SetParent(optionsCanvas);
	optionsCanvas.AnnotTopCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.AnnotTopCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.AnnotTopCaption:SetSize(80,20);
	optionsCanvas.AnnotTopCaption:SetPosition(optionsCanvas:GetWidth()/2,optionsCanvas.AnnotLeftCaption:GetTop());
	optionsCanvas.AnnotTopCaption:SetText(Resource[Settings.language][282]..":")

	optionsCanvas.AnnotTopValue=Turbine.UI.Lotro.TextBox();
	optionsCanvas.AnnotTopValue:SetParent(optionsCanvas);
	optionsCanvas.AnnotTopValue:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.AnnotTopValue:SetForeColor(Settings.fontColor);
	optionsCanvas.AnnotTopValue:SetSize(80,20);
	optionsCanvas.AnnotTopValue:SetPosition(optionsCanvas.AnnotTopCaption:GetLeft()+optionsCanvas.AnnotTopCaption:GetWidth()+5,optionsCanvas.AnnotTopCaption:GetTop());
	optionsCanvas.AnnotTopValue:SetText(tostring(quickWindow:GetTop()))

-- Show Quick Annotation control
	optionsCanvas.ShowQuickAnnotCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.ShowQuickAnnotCB:SetParent(optionsCanvas);
	optionsCanvas.ShowQuickAnnotCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.ShowQuickAnnotCB:SetForeColor(Settings.fontColor);
	optionsCanvas.ShowQuickAnnotCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.ShowQuickAnnotCB:SetPosition(10,optionsCanvas.AnnotTopCaption:GetTop()+optionsCanvas.AnnotTopCaption:GetHeight()+4);
	optionsCanvas.ShowQuickAnnotCB:SetText(Resource[Settings.language][160]);

	optionsCanvas.QAOpacityCaption=Turbine.UI.Label();
	optionsCanvas.QAOpacityCaption:SetParent(optionsCanvas);
	optionsCanvas.QAOpacityCaption:SetPosition(10,optionsCanvas.ShowQuickAnnotCB:GetTop()+optionsCanvas.ShowQuickAnnotCB:GetHeight()+9);
	optionsCanvas.QAOpacityCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.QAOpacityCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.QAOpacityCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.QAOpacityCaption:SetText(Resource[Settings.language][161]..":");
	optionsCanvas.QAOpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	optionsCanvas.QAOpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	optionsCanvas.QAOpacityScrollbar:SetParent(optionsCanvas)
	optionsCanvas.QAOpacityScrollbar:SetPosition(optionsCanvas.QAOpacityCaption:GetLeft()+optionsCanvas.QAOpacityCaption:GetWidth()+5,optionsCanvas.QAOpacityCaption:GetTop());
	optionsCanvas.QAOpacityScrollbar:SetSize(optionsCanvas:GetWidth()-optionsCanvas.QAOpacityCaption:GetWidth()-optionsCanvas.QAOpacityCaption:GetLeft()-15,10);
	optionsCanvas.QAOpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	optionsCanvas.QAOpacityScrollbar:SetMinimum(0);
	optionsCanvas.QAOpacityScrollbar:SetMaximum(100);
	optionsCanvas.QAOpacityScrollbar.OriginalValue=15;
	optionsCanvas.QAOpacityScrollbar.ValueChanged=function()
		quickWindow:SetOpacity(optionsCanvas.QAOpacityScrollbar:GetValue()/100);
	end

	optionsCanvas.CustAnnotCaption=Turbine.UI.Label();
	optionsCanvas.CustAnnotCaption:SetParent(optionsCanvas);
	optionsCanvas.CustAnnotCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	optionsCanvas.CustAnnotCaption:SetForeColor(Settings.headingsColor);
	optionsCanvas.CustAnnotCaption:SetSize(optionsCanvas:GetWidth(),20);
	optionsCanvas.CustAnnotCaption:SetPosition(0,optionsCanvas.QAOpacityCaption:GetTop()+30);
	optionsCanvas.CustAnnotCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	optionsCanvas.CustAnnotCaption:SetText(Resource[Settings.language][414]);

	optionsCanvas.CustAnnotSep=Turbine.UI.Control();
	optionsCanvas.CustAnnotSep:SetParent(optionsCanvas);
	optionsCanvas.CustAnnotSep:SetBackColor(Settings.headingsColor);
	optionsCanvas.CustAnnotSep:SetSize(optionsCanvas:GetWidth(),1);
	optionsCanvas.CustAnnotSep:SetPosition(0,optionsCanvas.CustAnnotCaption:GetTop()+optionsCanvas.CustAnnotCaption:GetHeight()+1);

	optionsCanvas.EnableCustShareCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.EnableCustShareCB:SetParent(optionsCanvas);
	optionsCanvas.EnableCustShareCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.EnableCustShareCB:SetForeColor(Settings.fontColor);
	optionsCanvas.EnableCustShareCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.EnableCustShareCB:SetPosition(10,optionsCanvas.CustAnnotCaption:GetTop()+optionsCanvas.CustAnnotCaption:GetHeight()+9);
	optionsCanvas.EnableCustShareCB:SetText(Resource[Settings.language][415]);

	optionsCanvas.EnableTMCompatCaption=Turbine.UI.Label();
	optionsCanvas.EnableTMCompatCaption:SetParent(optionsCanvas);
	optionsCanvas.EnableTMCompatCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.EnableTMCompatCaption:SetForeColor(Settings.fontColor);
	optionsCanvas.EnableTMCompatCaption:SetSize(optionsCanvas:GetWidth(),20);
	optionsCanvas.EnableTMCompatCaption:SetPosition(0,optionsCanvas.EnableCustShareCB:GetTop()+optionsCanvas.EnableCustShareCB:GetHeight()+9);
	optionsCanvas.EnableTMCompatCaption:SetText(Resource[Settings.language][416]);
	optionsCanvas.EnableTMCompat=RadioButtonGroup()
-----------------------------
	optionsCanvas.EnableTMCompat:SetParent(optionsCanvas);
	optionsCanvas.EnableTMCompat:SetSize(optionsCanvas:GetWidth(),20);
	optionsCanvas.EnableTMCompat:SetPosition(0,optionsCanvas.EnableTMCompatCaption:GetTop()+optionsCanvas.EnableTMCompatCaption:GetHeight()+9);
	optionsCanvas.EnableTMCompat.UnselectedIcon=resourcePath.."RB_unselected.tga";
	optionsCanvas.EnableTMCompat.SelectedIcon=resourcePath.."RB_selected.tga";
	optionsCanvas.EnableTMCompat.IconWidth=16;
	optionsCanvas.EnableTMCompat.IconHeight=16;
	optionsCanvas.EnableTMCompat:SetBorderColor(Settings.backColor);
	optionsCanvas.EnableTMCompat:SetBackColor(Settings.backColor);
	optionsCanvas.EnableTMCompat:SetTextColor(Settings.fontColor);
	optionsCanvas.EnableTMCompat:AddChoice(Resource[Settings.language][418]);
	optionsCanvas.EnableTMCompat:AddChoice(Resource[Settings.language][419]);
	optionsCanvas.EnableTMCompat:AddChoice(Resource[Settings.language][420]);
	optionsCanvas.EnableTMCompat:SetRows(1);
----------------------------

	optionsCanvas.MiscCaption=Turbine.UI.Label();
	optionsCanvas.MiscCaption:SetParent(optionsCanvas);
	optionsCanvas.MiscCaption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	optionsCanvas.MiscCaption:SetForeColor(Settings.headingsColor);
	optionsCanvas.MiscCaption:SetSize(optionsCanvas:GetWidth(),20);
	optionsCanvas.MiscCaption:SetPosition(0,optionsCanvas.EnableTMCompat:GetTop()+30);
	optionsCanvas.MiscCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	optionsCanvas.MiscCaption:SetText(Resource[Settings.language][286]);

	optionsCanvas.MiscSep=Turbine.UI.Control();
	optionsCanvas.MiscSep:SetParent(optionsCanvas);
	optionsCanvas.MiscSep:SetBackColor(Settings.headingsColor);
	optionsCanvas.MiscSep:SetSize(optionsCanvas:GetWidth(),1);
	optionsCanvas.MiscSep:SetPosition(0,optionsCanvas.MiscCaption:GetTop()+optionsCanvas.MiscCaption:GetHeight()+1);

-- Other Options ?
	optionsCanvas.WaypointCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.WaypointCB:SetParent(optionsCanvas);
	optionsCanvas.WaypointCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.WaypointCB:SetForeColor(Settings.fontColor);
	optionsCanvas.WaypointCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.WaypointCB:SetPosition(10,optionsCanvas.MiscCaption:GetTop()+optionsCanvas.MiscCaption:GetHeight()+9);
	optionsCanvas.WaypointCB:SetText(Resource[Settings.language][212]);

	optionsCanvas.WaypointMsg=Turbine.UI.Label();
	optionsCanvas.WaypointMsg:SetParent(optionsCanvas);
	optionsCanvas.WaypointMsg:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.WaypointMsg:SetForeColor(Settings.fontColor);
	optionsCanvas.WaypointMsg:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.WaypointMsg:SetPosition(10,optionsCanvas.WaypointCB:GetTop());
	optionsCanvas.WaypointMsg:SetText(Resource[Settings.language][213]);

	optionsCanvas.RespondToLocWhenMinimizedCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.RespondToLocWhenMinimizedCB:SetParent(optionsCanvas);
	optionsCanvas.RespondToLocWhenMinimizedCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.RespondToLocWhenMinimizedCB:SetForeColor(Settings.fontColor);
	optionsCanvas.RespondToLocWhenMinimizedCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.RespondToLocWhenMinimizedCB:SetPosition(10,optionsCanvas.WaypointCB:GetTop()+optionsCanvas.WaypointCB:GetHeight()+4);
	optionsCanvas.RespondToLocWhenMinimizedCB:SetText(Resource[Settings.language][461]);

	optionsCanvas.DebugCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.DebugCB:SetParent(optionsCanvas);
	optionsCanvas.DebugCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	optionsCanvas.DebugCB:SetForeColor(Settings.fontColor);
	optionsCanvas.DebugCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.DebugCB:SetPosition(10,optionsCanvas.RespondToLocWhenMinimizedCB:GetTop()+optionsCanvas.RespondToLocWhenMinimizedCB:GetHeight()+4);
	optionsCanvas.DebugCB:SetText(Resource[Settings.language][211]);

--** SAVE AND CANCEL
	optionsPanel.SaveButton=Turbine.UI.Lotro.Button();
	optionsPanel.SaveButton:SetParent(optionsPanel);
	optionsPanel.SaveButton:SetSize(100,20);
	optionsPanel.SaveButton:SetFont(Turbine.UI.Lotro.Font.Verdana18)
	optionsPanel.SaveButton:SetPosition(20,optionsPanel:GetHeight()-20);
	optionsPanel.SaveButton:SetText(Resource[Settings.language][11]);
	optionsPanel.SaveButton.Click=function()
		local hasError=false;
		-- validate option values
		local val=tonumber(optionsCanvas.MapTopValue:GetText())
		if val==nil or val<0 then
			optionsCanvas.MapTopValue:SetText("0")
			optionsCanvas.MapTopValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		elseif val>displayHeight-10 then
			optionsCanvas.MapTopValue:SetText(tostring(displayHeight-10))
			optionsCanvas.MapTopValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		end
		val=tonumber(optionsCanvas.MapLeftValue:GetText())
		if val==nil or val<0 then
			optionsCanvas.MapLeftValue:SetText("0")
			optionsCanvas.MapLeftValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		elseif val>displayWidth-10 then
			optionsCanvas.MapLeftValue:SetText(tostring(displayWidth-10))
			optionsCanvas.MapLeftValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		end

		val=tonumber(optionsCanvas.MapHeightValue:GetText())
		if val==nil or val<mapWindow.GetMinimumHeight() then
			optionsCanvas.MapHeightValue:SetText(tostring(mapWindow.GetMinimumHeight()))
			optionsCanvas.MapHeightValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		elseif val>displayHeight then
			optionsCanvas.MapHeightValue:SetText(tostring(displayHeight))
			optionsCanvas.MapHeightValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		end
		val=tonumber(optionsCanvas.MapWidthValue:GetText())
		if val==nil or val<mapWindow.GetMinimumWidth() then
			optionsCanvas.MapWidthValue:SetText(tostring(mapWindow.GetMinimumWidth()))
			optionsCanvas.MapWidthValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		elseif val>displayWidth then
			optionsCanvas.MapWidthValue:SetText(tostring(displayWidth))
			optionsCanvas.MapWidthValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		end

		val=tonumber(optionsCanvas.IconTopValue:GetText())
		if val==nil or val<0 then
			optionsCanvas.IconTopValue:SetText("0")
			optionsCanvas.IconTopValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		elseif val>displayHeight-minWindow:GetHeight() then
			optionsCanvas.IconTopValue:SetText(tostring(displayHeight-minWindow:GetHeight()))
			optionsCanvas.IconTopValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		end
		val=tonumber(optionsCanvas.IconLeftValue:GetText())
		if val==nil or val<0 then
			optionsCanvas.IconLeftValue:SetText("0")
			optionsCanvas.IconLeftValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		elseif val>displayWidth-minWindow:GetWidth() then
			optionsCanvas.IconLeftValue:SetText(tostring(displayWidth-minWindow:GetWidth()))
			optionsCanvas.IconLeftValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		end

		val=tonumber(optionsCanvas.AnnotTopValue:GetText())
		if val==nil or val<0 then
			optionsCanvas.AnnotTopValue:SetText("0")
			optionsCanvas.AnnotTopValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		elseif val>displayHeight-32 then
			optionsCanvas.AnnotTopValue:SetText(tostring(displayHeight-32))
			optionsCanvas.AnnotTopValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		end
		val=tonumber(optionsCanvas.AnnotLeftValue:GetText())
		if val==nil or val<0 then
			optionsCanvas.AnnotLeftValue:SetText("0")
			optionsCanvas.AnnotLeftValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		elseif val>displayWidth-32 then
			optionsCanvas.AnnotLeftValue:SetText(tostring(displayWidth-32))
			optionsCanvas.AnnotLeftValue:SetForeColor(Turbine.UI.Color.Red)
			hasError=true
		end

		if hasError then
			optionsPanel.ErrorLabel:SetVisible(true);
			optionsCanvas.HadErrors=true;
			optionsCanvas.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			optionsCanvas:SetWantsUpdates(true);
		else
			Settings.EnableCustomSharing=optionsCanvas.EnableCustShareCB:IsChecked()
			debug=optionsCanvas.DebugCB:IsChecked()
			Settings.EnableWaypoint=optionsCanvas.WaypointCB:IsChecked()
			if debug then debugWindow:SetVisible(true) end
			Settings.loadMinimized=optionsCanvas.LoadMinimizedCB:IsChecked()
			Settings.lockAspect=optionsCanvas.LockAspectCB:IsChecked()
			Settings.showIconWhenMinimized=optionsCanvas.ShowIconWhenMinimizedCB:IsChecked()
			minWindow:SetUseMiniIcon(optionsCanvas.UseMiniIconCB:IsChecked())
			minWindow:SetMiniIconOpaque(optionsCanvas.MiniIconOpaqueCB:IsChecked())
			quickWindow.Displayed=optionsCanvas.ShowQuickAnnotCB:IsChecked()
			quickWindow:SetVisible(quickWindow.Displayed)
			quickWindow.Opacity=optionsCanvas.QAOpacityScrollbar:GetValue()/100
			
			Settings.fontColor=optionsCanvas.FontColor:GetColor()
			Settings.trimColor=optionsCanvas.TrimColor:GetColor()
			Settings.backColor=optionsCanvas.BackColor:GetColor()
			Settings.headingsColor=optionsCanvas.HeadingsColor:GetColor()
			Settings.listTextColor=optionsCanvas.ListTextColor:GetColor()
			Settings.RespondToLocWhenMinimized=optionsCanvas.RespondToLocWhenMinimizedCB:IsChecked()
			local newLanguage=optionsCanvas.LanguageList:GetValue()
			local newWorldName=optionsCanvas.WorldList:GetValue()
			if newLanguage==0 then
				Settings.useClientLanguage=true
				if locale=="de" then
					newLanguage=3
				elseif locale=="fr" then
					newLanguage=2
				else
					newLanguage=1
				end
			else
				Settings.useClientLanguage=false
			end
			if newLanguage~=Settings.language or (Settings.worldName~=newWorldName and mapWindow.CurrentMapID==1) then
				Settings.language=newLanguage
				mapWindow:SetLanguage()
				overlayWindow:SetLanguage()
			end

			mapWindow:SetFontColor()
			mapWindow:SetTrimColor()
			mapWindow:SetBackColor()
			mapWindow:SetHeadingsColor()
			mapWindow:SetListTextColor()

			annotWindow:SetFontColor()
			annotWindow:SetTrimColor()
			annotWindow:SetBackColor()
			annotWindow:SetHeadingsColor()
			annotWindow:SetListTextColor()

			iconMaint:SetFontColor()
			iconMaint:SetTrimColor()
			iconMaint:SetBackColor()
			iconMaint:SetHeadingsColor()
			iconMaint:SetListTextColor()

			overlayWindow:SetFontColor()
			overlayWindow:SetTrimColor()
			overlayWindow:SetBackColor()
			overlayWindow:SetHeadingsColor()
			overlayWindow:SetListTextColor()

			searchWindow:SetFontColor()
			searchWindow:SetTrimColor()
			searchWindow:SetBackColor()
			searchWindow:SetHeadingsColor()
			searchWindow:SetListTextColor()
			breadcrumbWindow:SetFontColor()
			local TMCompat=optionsCanvas.EnableTMCompat:GetSelectedChoice()
			if TMCompat==3 then
				Settings.TerrainMapCompatability=nil
			else
				Settings.TerrainMapCompatability=(TMCompat==1)
			end

			Settings.defaultMap=optionsCanvas.DefaultMapList:GetValue()
			if (Settings.worldName~=newWorldName and mapWindow.CurrentMapID==1 or Settings.TerrainMapCompatability==nil) then
				Settings.worldName=newWorldName
				mapWindow.PreserveMapID=true
				-- load the plugin that will unload and reload this plugin (we can only read the annotation files without a 15 second delay while we are "loading")
				Turbine.PluginManager.LoadPlugin("MoorMapLoader")
			else
				Settings.worldName=newWorldName
				annotWindow:SetLanguage()
				annotWindow:LoadAnnotationList(); -- force reload of the translated values
				mapWindow.Map.IconSearch.OldText=tostring(mapWindow.Map.IconSearch.OldText).."X"; -- any change to the old text will force a refresh in case there was a filter applied
				mapWindow.NeedsRefresh=true
				mapWindow:SetWantsUpdates(true); -- will reload all map components, including icon search list
			end
			if optionsCanvas.LockAspectCB:IsChecked() then
				mapWindow:SetSize(0,0) -- will force a size changed event
			end
			mapWindow:SetSize(tonumber(optionsCanvas.MapWidthValue:GetText()),tonumber(optionsCanvas.MapHeightValue:GetText()))
			mapWindow:SetPosition(tonumber(optionsCanvas.MapLeftValue:GetText()),tonumber(optionsCanvas.MapTopValue:GetText()))
			minWindow:SetPosition(tonumber(optionsCanvas.IconLeftValue:GetText()),tonumber(optionsCanvas.IconTopValue:GetText()))
			quickWindow:SetPosition(tonumber(optionsCanvas.AnnotLeftValue:GetText()),tonumber(optionsCanvas.AnnotTopValue:GetText()))
			optionsWindow:SetVisible(false);
		end
	end

	optionsPanel.CancelButton=Turbine.UI.Lotro.Button();
	optionsPanel.CancelButton:SetParent(optionsPanel);
	optionsPanel.CancelButton:SetSize(100,20);
	optionsPanel.CancelButton:SetFont(Turbine.UI.Lotro.Font.Verdana18)
	optionsPanel.CancelButton:SetPosition(optionsPanel:GetWidth()-20-optionsPanel.CancelButton:GetWidth(),optionsPanel:GetHeight()-20);
	optionsPanel.CancelButton:SetText(Resource[Settings.language][12]);
	optionsPanel.CancelButton.Click=function()
		mapWindow.Map:SetOpacity(optionsCanvas.OpacityScrollbar.OriginalValue);
		quickWindow:SetOpacity(optionsCanvas.QAOpacityScrollbar.OriginalValue);
		optionsCanvas.FontColor:SetColor(Settings.fontColor);
		optionsCanvas.TrimColor:SetColor(Settings.trimColor);
		optionsCanvas.BackColor:SetColor(Settings.backColor);
		optionsCanvas.HeadingsColor:SetColor(Settings.headingsColor);
		optionsWindow:SetVisible(false);
	end

	optionsPanel.ErrorLabel=Turbine.UI.Label();
	optionsPanel.ErrorLabel:SetParent(optionsPanel);
	optionsPanel.ErrorLabel:SetText(Resource[Settings.language][333])
	optionsPanel.ErrorLabel:SetPosition(optionsPanel.SaveButton:GetLeft()+optionsPanel.SaveButton:GetWidth(),optionsPanel.SaveButton:GetTop());
	optionsPanel.ErrorLabel:SetSize(optionsPanel.CancelButton:GetLeft()-(optionsPanel.ErrorLabel:GetLeft()),optionsPanel.SaveButton:GetHeight());
	optionsPanel.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18);
	optionsPanel.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
	optionsPanel.ErrorLabel:SetVisible(false);
	optionsPanel.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	optionsCanvas.DefaultMapList:SetZOrder(optionsPanel.ErrorLabel:GetZOrder()+1)
	optionsCanvas.WorldList:SetZOrder(optionsCanvas.DefaultMapList:GetZOrder()+1);
	optionsCanvas.LanguageList:SetZOrder(optionsCanvas.WorldList:GetZOrder()+1);

	optionsCanvas.Update=function(sender,args)
		if optionsCanvas.HadErrors then
			if Turbine.Engine:GetGameTime()>optionsCanvas.ErrorFadeTime then
				optionsCanvas:SetWantsUpdates(false);
				optionsPanel.ErrorLabel:SetVisible(false);
				optionsCanvas.HadErrors=false
			end
		end
	end
	optionsCanvas.SetTrimColor=function(sender,color)
		optionsCanvas.LanguageList:SetBorderColor(color);
		optionsCanvas.WorldList:SetBorderColor(color);
		optionsCanvas.DefaultMapList:SetBorderColor(color);
		optionsCanvas.FontColor:SetTrimColor(color);
		optionsCanvas.TrimColor:SetTrimColor(color);
		optionsCanvas.BackColor:SetTrimColor(color);
		optionsCanvas.HeadingsColor:SetTrimColor(color);
		optionsCanvas.ListTextColor:SetTrimColor(color);
		optionsCanvas.EnableTMCompat:SetBorderColor(color);
	end
	optionsCanvas.SetBackColor=function(sender,color)
		Turbine.UI.Control.SetBackColor(optionsCanvas,color);
		optionsCanvas.LanguageList:SetBackColor(color);
		optionsCanvas.LanguageList:SetCurrentBackColor(color);
		optionsCanvas.WorldList:SetBackColor(color);
		optionsCanvas.WorldList:SetCurrentBackColor(color);
		optionsCanvas.DefaultMapList:SetBackColor(color);
		optionsCanvas.DefaultMapList:SetCurrentBackColor(color);
		optionsCanvas.FontColor:SetBackColor(color);
		optionsCanvas.TrimColor:SetBackColor(color);
		optionsCanvas.BackColor:SetBackColor(color);
		optionsCanvas.HeadingsColor:SetBackColor(color);
		optionsCanvas.ListTextColor:SetBackColor(color);
		optionsCanvas.EnableTMCompat:SetBackColor(color);
	end
	optionsCanvas.SetFontColor=function(sender,color)
		optionsCanvas.LanguageCaption:SetForeColor(color);
		optionsCanvas.WorldCaption:SetForeColor(color);
		optionsCanvas.DefaultMapCaption:SetForeColor(color);
		optionsCanvas.LoadMinimizedCB:SetForeColor(color);
		optionsCanvas.LockAspectCB:SetForeColor(color);
		optionsCanvas.ShowIconWhenMinimizedCB:SetForeColor(color);
		optionsCanvas.UseMiniIconCB:SetForeColor(color);
		optionsCanvas.MiniIconOpaqueCB:SetForeColor(color);
		optionsCanvas.TrimCaption:SetForeColor(color);
		optionsCanvas.FontCaption:SetForeColor(color);
		optionsCanvas.BackCaption:SetForeColor(color);
		optionsCanvas.HeadingsCaption:SetForeColor(color);
		optionsCanvas.ListTextCaption:SetForeColor(color);
		optionsCanvas.OpacityCaption:SetForeColor(color);
		optionsCanvas.MapLeftCaption:SetForeColor(color);
		optionsCanvas.MapTopCaption:SetForeColor(color);
		optionsCanvas.MapWidthCaption:SetForeColor(color);
		optionsCanvas.MapHeightCaption:SetForeColor(color);
		optionsCanvas.IconLeftCaption:SetForeColor(color);
		optionsCanvas.IconTopCaption:SetForeColor(color);
		optionsCanvas.AnnotLeftCaption:SetForeColor(color);
		optionsCanvas.AnnotTopCaption:SetForeColor(color);

		optionsCanvas.QAOpacityCaption:SetForeColor(color)
		optionsCanvas.ShowQuickAnnotCB:SetForeColor(color);
		optionsCanvas.EnableCustShareCB:SetForeColor(color);
		optionsCanvas.WaypointCB:SetForeColor(color);
		optionsCanvas.WaypointMsg:SetForeColor(color)
		optionsCanvas.DebugCB:SetForeColor(color);
		optionsCanvas.EnableTMCompatCaption:SetForeColor(color);
		optionsCanvas.EnableTMCompat:SetTextColor(color);
		optionsCanvas.RespondToLocWhenMinimizedCB:SetForeColor(color)

	end
	optionsCanvas.SetHeadingsColor=function(sender,color)
		optionsCanvas.OptionsCaption:SetForeColor(color);
		optionsCanvas.MapCaption:SetForeColor(color);
		optionsCanvas.IconCaption:SetForeColor(color);
		optionsCanvas.AnnotCaption:SetForeColor(color);
		optionsCanvas.MiscCaption:SetForeColor(color);
		optionsCanvas.CustAnnotCaption:SetForeColor(color)
		optionsCanvas.OptionsSep:SetBackColor(color);
		optionsCanvas.MapSep:SetBackColor(color);
		optionsCanvas.IconSep:SetBackColor(color);
		optionsCanvas.AnnotSep:SetBackColor(color);
		optionsCanvas.MiscSep:SetBackColor(color);
		optionsCanvas.CustAnnotSep:SetBackColor(color)
	end
	optionsCanvas.SetListTextColor=function(sender,color)
		optionsCanvas.LanguageList:SetTextColor(color);
		optionsCanvas.WorldList:SetTextColor(color);
		optionsCanvas.DefaultMapList:SetTextColor(color);
	end

	optionsCanvas.SetLanguage=function(sender,tmpLanguage)
		optionsCanvas.OptionsCaption:SetText(Resource[tmpLanguage][4]);
		optionsCanvas.LanguageCaption:SetText(Resource[tmpLanguage][5]..":");
		optionsCanvas.WorldCaption:SetText(Resource[tmpLanguage][149]..":");
		optionsCanvas.DefaultMapCaption:SetText(Resource[tmpLanguage][200]..":");
		optionsCanvas.TrimCaption:SetText(Resource[tmpLanguage][6]..":");
		optionsCanvas.BackCaption:SetText(Resource[tmpLanguage][7]..":");
		optionsCanvas.FontCaption:SetText(Resource[tmpLanguage][8]..":");
		optionsCanvas.HeadingsCaption:SetText(Resource[tmpLanguage][15]..":");
		optionsCanvas.ListTextCaption:SetText(Resource[tmpLanguage][16]..":");
		optionsCanvas.ResetColors:SetText(Resource[tmpLanguage][9]);
		optionsCanvas.OpacityCaption:SetText(Resource[tmpLanguage][71]..":");

		optionsCanvas.MapCaption:SetText(Resource[tmpLanguage][279]);
		optionsCanvas.IconCaption:SetText(Resource[tmpLanguage][280]);
		optionsCanvas.AnnotCaption:SetText(Resource[tmpLanguage][285]);
		optionsCanvas.MiscCaption:SetText(Resource[tmpLanguage][286]);
		optionsCanvas.LoadMinimizedCB:SetText(Resource[tmpLanguage][17]);
		optionsCanvas.LockAspectCB:SetText(Resource[tmpLanguage][390]);
		optionsCanvas.ShowIconWhenMinimizedCB:SetText(Resource[tmpLanguage][18]);
		optionsCanvas.UseMiniIconCB:SetText(Resource[tmpLanguage][201]);
		optionsCanvas.MiniIconOpaqueCB:SetText(Resource[tmpLanguage][202]);
		optionsCanvas.ShowQuickAnnotCB:SetText(Resource[tmpLanguage][160]);
		optionsCanvas.QAOpacityCaption:SetText(Resource[tmpLanguage][161]..":");
		optionsCanvas.CustAnnotCaption:SetText(Resource[tmpLanguage][414]);	
		optionsCanvas.EnableCustShareCB:SetText(Resource[tmpLanguage][415])
		optionsCanvas.EnableTMCompatCaption:SetText(Resource[tmpLanguage][416]);
		optionsCanvas.EnableTMCompat.Choices[1].Caption:SetText(Resource[tmpLanguage][418]);
		optionsCanvas.EnableTMCompat.Choices[2].Caption:SetText(Resource[tmpLanguage][419]);
		optionsCanvas.EnableTMCompat.Choices[3].Caption:SetText(Resource[tmpLanguage][420]);

		optionsCanvas.WaypointCB:SetText(Resource[tmpLanguage][212]);
		optionsCanvas.DebugCB:SetText(Resource[tmpLanguage][211]);
		optionsCanvas.RespondToLocWhenMinimizedCB:SetText(Resource[tmpLanguage][461])

		optionsPanel.SaveButton:SetText(Resource[tmpLanguage][11]);
		optionsPanel.CancelButton:SetText(Resource[tmpLanguage][12]);

		optionsCanvas.MapLeftCaption:SetText(Resource[tmpLanguage][281]..":")
		optionsCanvas.MapTopCaption:SetText(Resource[tmpLanguage][282]..":")
		optionsCanvas.MapWidthCaption:SetText(Resource[tmpLanguage][283]..":")
		optionsCanvas.MapHeightCaption:SetText(Resource[tmpLanguage][284]..":")
		optionsCanvas.IconLeftCaption:SetText(Resource[tmpLanguage][281]..":")
		optionsCanvas.IconTopCaption:SetText(Resource[tmpLanguage][282]..":")
		optionsCanvas.AnnotLeftCaption:SetText(Resource[tmpLanguage][281]..":")
		optionsCanvas.AnnotTopCaption:SetText(Resource[tmpLanguage][282]..":")
	end

	-- refresh the options status to reflect current values
	optionsWindow.RefreshOptions=function()
		optionsCanvas.OpacityScrollbar:SetValue(math.floor(mapWindow.Map:GetOpacity()*100));
		optionsCanvas.OpacityScrollbar.OriginalValue=mapWindow.Map:GetOpacity();
		optionsCanvas.QAOpacityScrollbar:SetValue(math.floor(quickWindow:GetOpacity()*100));
		optionsCanvas.QAOpacityScrollbar.OriginalValue=quickWindow:GetOpacity();
		optionsCanvas.LoadMinimizedCB:SetChecked(Settings.loadMinimized);
		optionsCanvas.LockAspectCB:SetChecked(Settings.lockAspect);
		optionsCanvas.ShowIconWhenMinimizedCB:SetChecked(Settings.showIconWhenMinimized);
		optionsCanvas.UseMiniIconCB:SetChecked(minWindow:GetUseMiniIcon());
		optionsCanvas.MiniIconOpaqueCB:SetChecked(minWindow:GetMiniIconOpaque());
		optionsCanvas.ShowQuickAnnotCB:SetChecked(quickWindow.Displayed);
		optionsCanvas.WaypointCB:SetChecked(Settings.EnableWaypoint);
		optionsCanvas.DebugCB:SetChecked(debug);
		optionsCanvas.EnableCustShareCB:SetChecked(Settings.EnableCustomSharing)
		optionsCanvas.RespondToLocWhenMinimizedCB:SetChecked(Settings.RespondToLocWhenMinimized)
		if Settings.TerrainMapCompatability==nil then
			optionsCanvas.EnableTMCompat:SetSelectedChoice(3)
		elseif Settings.TerrainMapCompatability then
			optionsCanvas.EnableTMCompat:SetSelectedChoice(1)
		else
			optionsCanvas.EnableTMCompat:SetSelectedChoice(2)
		end

		optionsCanvas.MapLeftValue:SetText(tostring(mapWindow:GetLeft()))
		optionsCanvas.MapTopValue:SetText(tostring(mapWindow:GetTop()))
		optionsCanvas.MapWidthValue:SetText(tostring(mapWindow:GetWidth()))
		optionsCanvas.MapHeightValue:SetText(tostring(mapWindow:GetHeight()))
		optionsCanvas.IconLeftValue:SetText(tostring(minWindow:GetLeft()))
		optionsCanvas.IconTopValue:SetText(tostring(minWindow:GetTop()))
		optionsCanvas.AnnotLeftValue:SetText(tostring(quickWindow:GetLeft()))
		optionsCanvas.AnnotTopValue:SetText(tostring(quickWindow:GetTop()))
		
		optionsCanvas.MapLeftValue:SetForeColor(Settings.fontColor)
		optionsCanvas.MapTopValue:SetForeColor(Settings.fontColor)
		optionsCanvas.MapWidthValue:SetForeColor(Settings.fontColor)
		optionsCanvas.MapHeightValue:SetForeColor(Settings.fontColor)
		optionsCanvas.IconLeftValue:SetForeColor(Settings.fontColor)
		optionsCanvas.IconTopValue:SetForeColor(Settings.fontColor)
		optionsCanvas.AnnotLeftValue:SetForeColor(Settings.fontColor)
		optionsCanvas.AnnotTopValue:SetForeColor(Settings.fontColor)
	end
	optionsWindow.RefreshOptions()

	do
		local index;
		local tmpLanguage=Settings.language
		if Settings.useClientLanguage then
			tmpLanguage=0
		end
		for index=1,optionsCanvas.LanguageList.ListData:GetItemCount() do
			if optionsCanvas.LanguageList.ListData:GetItem(index):GetValue()==tmpLanguage then
				optionsCanvas.LanguageList:SetSelectedIndex(index);
				break;
			end
		end
	end
	for index=1,optionsCanvas.WorldList.ListData:GetItemCount() do
		if optionsCanvas.WorldList.ListData:GetItem(index).DataValue==Settings.worldName then
			optionsCanvas.WorldList:SetSelectedIndex(index);
			break;
		end
	end
	for index=1,optionsCanvas.DefaultMapList.ListData:GetItemCount() do
		if optionsCanvas.DefaultMapList.ListData:GetItem(index):GetValue()==Settings.defaultMap then
			optionsCanvas.DefaultMapList:SetSelectedIndex(index);
			break;
		end
	end
	optionsCanvas:SetLanguage(Settings.language);

	optionsPanel.HScroll=Turbine.UI.Lotro.ScrollBar();
	optionsPanel.HScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
	optionsPanel.HScroll:SetParent(optionsPanel);
	optionsPanel.HScroll:SetBackColor(Settings.backColor);
	optionsPanel.HScroll:SetPosition(0,optionsViewPane:GetHeight());
	optionsPanel.HScroll:SetWidth(optionsViewPane:GetWidth());
	optionsPanel.HScroll:SetHeight(10);
	local max=optionsCanvas:GetWidth()-optionsViewPane:GetWidth()
	if max>0 then
		optionsPanel.HScroll:SetMaximum(max);
		optionsPanel.HScroll:SetVisible(true);
	else
		optionsPanel.HScroll:SetVisible(false);
	end
	optionsPanel.HScroll.ValueChanged=function()
		optionsCanvas:SetLeft(0-optionsPanel.HScroll:GetValue())
	end
	
	optionsPanel.VScroll=Turbine.UI.Lotro.ScrollBar();
	optionsPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	optionsPanel.VScroll:SetParent(optionsPanel);
	optionsPanel.VScroll:SetBackColor(Settings.backColor);
	optionsPanel.VScroll:SetPosition(optionsViewPane:GetWidth(),0);
	optionsPanel.VScroll:SetHeight(optionsViewPane:GetHeight());
	optionsPanel.VScroll:SetWidth(10);
	optionsPanel.VScroll:SetVisible(false);
	optionsPanel.VScroll.ValueChanged=function()
		optionsCanvas:SetTop(0-optionsPanel.VScroll:GetValue())
	end
	max=optionsCanvas:GetHeight()-optionsViewPane:GetHeight()
	if max>0 then
		optionsPanel.VScroll:SetMaximum(max);
		optionsPanel.VScroll:SetVisible(true);
	else
		optionsPanel.VScroll:SetVisible(false);
	end
