tmp.BDDScript=function(tmpData,tmpOLIndex)
	local success,result
	local topmost=100+#mapWindow.Map.Icons
	local isvisible=tmpData[8]
	local bddWidth=320
	local bddHeight=420
	if (BDDLegend.BDD==nil or BDDLegend.BDD[1]==nil) then
		BDD={}
		legend={}
		success,result=pcall(import,importPath.."Overlays.BDD.Data"..tostring(mapWindow.CurrentMapID));
		BDDLegend.BDD=BDD
		if BDDLegend.initialized==nil then
			BDDLegend.initialized=true
			BDDLegend:SetPosition(Settings.BDDLegendLeftPercent*displayWidth,Settings.BDDLegendTopPercent*displayHeight)
			if legend.width~=nil then
				bddWidth=legend.width
			end
			BDDLegend:SetSize(bddWidth,bddHeight)
			BDDLegend:SetZOrder(mapWindow:GetZOrder()+1)
			BDDLegend:SetOpacity(.95)
			BDDLegend:SetZOrder(2)
			BDDLegend:SetStretchMode(3);
			BDDVis=isvisible
			BDDLegend:SetVisible(isvisible and mapWindow:IsVisible())
			BDDLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
			BDDLegend.Border=Turbine.UI.Control()
			BDDLegend.Border:SetParent(BDDLegend)
			BDDLegend.Border:SetSize(bddWidth-2,bddHeight-2)
			BDDLegend.Border:SetPosition(1,1)
			if legend.backColor==nil then
				BDDLegend.Border:SetBackColor(Turbine.UI.Color(.95,.95,.85))
			else
				BDDLegend.Border:SetBackColor(legend.backColor)
			end
			BDDLegend.TitleBack=Turbine.UI.Control()
			BDDLegend.TitleBack:SetParent(BDDLegend.Border)
			BDDLegend.TitleBack:SetSize(bddWidth,65)
			BDDLegend.Title=Turbine.UI.Control()
			BDDLegend.Title:SetParent(BDDLegend.TitleBack)
			BDDLegend.Title:SetSize(250,65)
			BDDLegend.Title:SetPosition((bddWidth-252)/2,1)
			BDDLegend.Title:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			if legend.caption==nil then
				BDDLegend.Title:SetBackground(resourcePath.."BDDCaption.tga")
			else
				BDDLegend.Title:SetBackground("GaranStuff/MoorMap/Overlays/"..legend.caption)
			end
			BDDLegend.Title:SetMouseVisible(false)
			BDDLegend.TitleBack.MouseDown=function(sender,args)
				BDDLegend.Border:SetBackColor(Turbine.UI.Color(.8,.85,.85,.75))
				BDDLegend.X=args.X
				BDDLegend.Y=args.Y
				BDDLegend.Moving=true
			end
			BDDLegend.TitleBack.MouseMove=function(sender,args)
				if BDDLegend.Moving then
					BDDLegend:SetPosition(BDDLegend:GetLeft()-(BDDLegend.X-args.X),BDDLegend:GetTop()-(BDDLegend.Y-args.Y))
				end
			end
			BDDLegend.TitleBack.MouseUp=function(sender,args)
				BDDLegend.Border:SetBackColor(Turbine.UI.Color(.95,.95,.85))
				BDDLegend.Moving=false
			end
			BDDLegend.TitleBack.MouseLeave=function(sender,args)
				BDDLegend:SetBackground(nil); -- cheesy way to generate a checkerboard background
				BDDLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
			end
			BDDLegend.TitleBack.MouseEnter=function(sender,args)
				BDDLegend:SetBackground(0); -- cheesy way to generate a checkerboard background
				BDDLegend:SetBackColor(nil)
			end
			BDDLegend.FontCaption=Turbine.UI.Label()
			BDDLegend.FontCaption:SetParent(BDDLegend.Border)
			BDDLegend.FontCaption:SetSize(100,20)
			BDDLegend.FontCaption:SetPosition(2,72)
			if legend.fontForeColor==nil then legend.fontForeColor=Turbine.UI.Color(.2,.5,.2) end
			BDDLegend.FontCaption:SetForeColor(legend.fontForeColor)
			BDDLegend.FontCaption:SetText(Resource[Settings.language][345]..":")
			if Settings.BDDFontSize<23 then
				BDDLegend.FontIncrease=Turbine.UI.Label()
				BDDLegend.FontIncrease:SetParent(BDDLegend.Border)
				BDDLegend.FontIncrease:SetSize(20,20)
				BDDLegend.FontIncrease:SetPosition(107,72)
				BDDLegend.FontIncrease:SetForeColor(legend.fontForeColor)
				BDDLegend.FontIncrease:SetText("+")
				BDDLegend.FontIncrease.MouseClick=function(sender,args)
					local tmpFont=GetLargerFont(Settings.BDDFont)
					if tmpFont~=nil then
						Settings.BDDFont=tmpFont
						Settings.BDDFontSize=Turbine.UI.Lotro.FontInfo[Settings.BDDFont].size
						mapWindow.PreserveMapID=true;
						Turbine.PluginManager.LoadPlugin("MoorMapLoader");
					end
				end
			end
			BDDLegend.FontSizeCaption=Turbine.UI.Label()
			BDDLegend.FontSizeCaption:SetParent(BDDLegend.Border)
			BDDLegend.FontSizeCaption:SetSize(40,20)
			BDDLegend.FontSizeCaption:SetPosition(127,72)
			BDDLegend.FontSizeCaption:SetForeColor(legend.fontForeColor)
			BDDLegend.FontSizeCaption:SetText(Settings.BDDFontSize)
			if Settings.BDDFontSize>10 then
				BDDLegend.FontDecrease=Turbine.UI.Label()
				BDDLegend.FontDecrease:SetParent(BDDLegend.Border)
				BDDLegend.FontDecrease:SetSize(20,20)
				BDDLegend.FontDecrease:SetPosition(167,72)
				BDDLegend.FontDecrease:SetForeColor(legend.fontForeColor)
				BDDLegend.FontDecrease:SetText("-")
				BDDLegend.FontDecrease.MouseClick=function(sender,args)
					local tmpFont=GetSmallerFont(Settings.BDDFont)
					if tmpFont~=nil then
						Settings.BDDFont=tmpFont
						Settings.BDDFontSize=Turbine.UI.Lotro.FontInfo[Settings.BDDFont].size
						mapWindow.PreserveMapID=true;
						Turbine.PluginManager.LoadPlugin("MoorMapLoader");
					end
				end
			end

			BDDLegend.DeedList=Turbine.UI.TreeView()
			BDDLegend.DeedList:SetParent(BDDLegend.Border)
			BDDLegend.DeedList:SetSize(bddWidth-24,bddHeight-92)
			BDDLegend.DeedList:SetPosition(5,90)
			BDDLegend.VScroll=Turbine.UI.Lotro.ScrollBar()
			BDDLegend.VScroll:SetParent(BDDLegend.Border)
			BDDLegend.VScroll:SetSize(10,bddHeight-32);
			BDDLegend.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
			BDDLegend.VScroll:SetPosition(bddWidth-12,25);
			BDDLegend.DeedList:SetVerticalScrollBar(BDDLegend.VScroll)
			BDDLegend.Ping=Turbine.UI.Control();
			BDDLegend.Ping:SetParent(mapWindow.Map);
			BDDLegend.Ping:SetZOrder(topmost+1);
			BDDLegend.Ping.State=0;
			BDDLegend.Ping:SetVisible(false);
			BDDLegend.Ping:SetSize(23,23);
			BDDLegend.Ping:SetPosition(512,512);
			BDDLegend.Ping:SetWantsUpdates(false);
			BDDLegend.Ping.Counter=1;
			BDDLegend.Ping.MaxCounter=2;
			BDDLegend.Ping:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			BDDLegend.Ping:SetBackground(resourcePath.."Ping1.tga");
			BDDLegend.Ping.MouseClick=function(sender,args)
				BDDLegend.Ping.State=0; -- it will auto hide itmapWindow on next tick
			end
			BDDLegend.Ping.Update=function(sender)
				if BDDLegend.Ping.UpdateTime==nil then
					BDDLegend.Ping.UpdateTime=Turbine.Engine:GetGameTime()-.01
				end
				if BDDLegend.Ping.State==0 then
					BDDLegend.Ping:SetWantsUpdates(false);
					BDDLegend.Ping:SetVisible(false);
					BDDLegend.Ping.Counter=0;
					BDDLegend.Ping:SetBackground(resourcePath.."Ping1.tga");
				elseif Turbine.Engine:GetGameTime()>BDDLegend.Ping.UpdateTime then
					BDDLegend.Ping.UpdateTime=Turbine.Engine:GetGameTime()+.01
					if BDDLegend.Ping.State==7 then
						BDDLegend.Ping.Counter=BDDLegend.Ping.Counter+1;
						if BDDLegend.Ping.Counter>BDDLegend.Ping.MaxCounter then
							BDDLegend.Ping.Counter=0;
							BDDLegend.Ping.State=3;
							BDDLegend.Ping:SetBackground(resourcePath.."Ping3.tga");
						end
					else
						BDDLegend.Ping.Counter=BDDLegend.Ping.Counter+1;
						if BDDLegend.Ping.Counter>BDDLegend.Ping.MaxCounter then
							BDDLegend.Ping.Counter=0;
							BDDLegend.Ping.State=BDDLegend.Ping.State+1;
							BDDLegend.Ping:SetBackground(resourcePath.."Ping"..tostring(BDDLegend.Ping.State)..".tga");
						end
					end
				end
			end

			local root=BDDLegend.DeedList:GetNodes()
			for groupIndex,groupData in ipairs(BDDLegend.BDD) do
				local tmpNode=Turbine.UI.TreeNode()
				tmpNode:SetParent(BDDLegend.DeedList)
				tmpNode:SetSize(bddWidth-24,18)
				tmpNode.Icon=Turbine.UI.Control()
				tmpNode.Icon:SetParent(tmpNode)
				tmpNode.Icon:SetMouseVisible(false)
				tmpNode.Icon:SetSize(16,16)
				tmpNode.Icon:SetBackground(0x41007E27) -- expand
				tmpNode.Title=Turbine.UI.Label()
				tmpNode.Title:SetParent(tmpNode)
				tmpNode.Title:SetSize(bddWidth-42,18)
				tmpNode.Title:SetLeft(18)
				tmpNode.Title:SetForeColor(groupData[2])
				tmpNode.Title:SetFont(Turbine.UI.Lotro.Font.Verdana16)
				tmpNode.Title:SetFontStyle(Turbine.UI.FontStyle.Outline)
				tmpNode.Title:SetOutlineColor(Turbine.UI.Color(.3,.3,.3))
				tmpNode.Title:SetText(groupData[1])
				tmpNode.Title:SetMouseVisible(false)
				tmpNode.MouseDown=function(sender)
					if sender:IsExpanded() then
						sender.Icon:SetBackground(0x41007E27)
					else
						sender.Icon:SetBackground(0x41007E26)
					end
				end
				root:Add(tmpNode)
				for itemIndex,itemData in ipairs(BDDLegend.BDD[groupData[1]]) do
					-- only add node if name isn't already in tree
					local childNodes=tmpNode:GetChildNodes()
					local exists=false
					local tmpLabel
					if itemData[1]~=nil then
						tmpLabel=tostring(itemData[1]).." "..itemData[2]
						if itemData[1]<10 then tmpLabel="0"..tmpLabel end
					else
						tmpLabel=itemData[2]
					end
					local tmpLen=string.len(tmpLabel)
					if itemData[3]~=nil and itemData[4]~=nil then
						if itemData[3]<0 then
							tmpLabel=tmpLabel.." ("..tostring(0-itemData[3]).."S,"
						else
							tmpLabel=tmpLabel.." ("..tostring(itemData[3]).."N,"
						end
						if itemData[4]<0 then
							tmpLabel=tmpLabel..tostring(0-itemData[4]).."W)"
						else
							tmpLabel=tmpLabel..tostring(itemData[4]).."E)"
						end
					end
					if not exists then
						local tmpItemNode=Turbine.UI.TreeNode()
						tmpItemNode:SetParent(tmpNode)
						tmpItemNode:SetSize(bddWidth-24,16)
						tmpItemNode.Title=Turbine.UI.Label()
						tmpItemNode.Title:SetParent(tmpItemNode)
						tmpItemNode.Title:SetSize(bddWidth-44,16)
						tmpItemNode.Title:SetLeft(20)
						tmpItemNode.Title:SetForeColor(Turbine.UI.Color.DarkOliveGreen)
						tmpItemNode.Title:SetFont(Turbine.UI.Lotro.Font.Verdana14)
						tmpItemNode.Title:SetText(tmpLabel)
						tmpItemNode.Title:SetMouseVisible(false)
						if itemData[1]==nil and itemData[3]~=nil then
							-- map node
							tmpItemNode.MapID=itemData[3]
							tmpItemNode.MouseClick=function(sender)
								RefreshMap(sender.MapID)
							end
						end
						if itemData[1]~=nil and itemData[3]~=nil and itemData[4]~=nil then
							-- ping node
							if itemData[6]~=nil then
								tmpItemNode.X=math.floor(itemData[6]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
							else
								tmpItemNode.X=math.floor(itemData[4]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
							end
							if itemData[5]~=nil then
								tmpItemNode.Y=math.floor(itemData[5]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
							else
								tmpItemNode.Y=math.floor(itemData[3]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
							end
							tmpItemNode.MouseClick=function(sender)
								BDDLegend.Ping:SetPosition(math.floor(sender.X-11.5),math.floor(sender.Y-11.5));
								BDDLegend.Ping.State=1;
								BDDLegend.Ping:SetVisible(true);
								BDDLegend.Ping:SetWantsUpdates(true);
							end
						end
						childNodes:Add(tmpItemNode)
					end
				end
			end
		end
	end
	mapWindow.Map.Overlays[tmpOLIndex].HotSpots={}
	for groupIndex,groupData in ipairs(BDDLegend.BDD) do
		for itemIndex,itemData in ipairs(BDDLegend.BDD[groupData[1]]) do
			-- add the hotspot to the overlay
			if itemData[1]~=nil and itemData[3]~=nil and itemData[4]~=nil then
				local NS,EW=itemData[3],itemData[4]
				local X,Y
				if itemData[6]~=nil then
					X=math.floor(itemData[6]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
				else
					X=math.floor(EW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
				end
				if itemData[5]~=nil then
					Y=math.floor(itemData[5]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
				else
					Y=math.floor(NS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
				end
				local tmpHotSpot=Turbine.UI.Control()
				-- if the hotspots are on the overlay we don't get mouse events :(
				tmpHotSpot:SetParent(mapWindow.Map)
				tmpHotSpot:SetVisible(isvisible)
				tmpHotSpot:SetZOrder(topmost)
				tmpHotSpot:SetSize(Settings.BDDFontSize*1.5,Settings.BDDFontSize)
				tmpHotSpot:SetPosition(X-15,Y-10)
				-- create the text as a child so that the blendmode/backcolor alpha works correctly instead of poking holes in the map
				tmpHotSpot.Text=Turbine.UI.Label()
				tmpHotSpot.Text:SetParent(tmpHotSpot)
				tmpHotSpot.Text:SetSize(tmpHotSpot:GetSize())
				tmpHotSpot.Text:SetFont(Settings.BDDFont)
				tmpHotSpot.Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
				tmpHotSpot.Text:SetOutlineColor(Turbine.UI.Color.Black)
				tmpHotSpot.Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
				tmpHotSpot.Text:SetForeColor(groupData[2])
				tmpHotSpot.Text:SetMouseVisible(false)
				if itemData[1]<10 then
					tmpHotSpot.Text:SetText("0"..tostring(itemData[1]))
				else
					tmpHotSpot.Text:SetText(itemData[1])
				end
				tmpHotSpot.Text:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
				tmpHotSpot.Text:SetBackColor(Turbine.UI.Color(.6,.7,.8,.8))
				tmpHotSpot.ShortDescription=itemData[2]
				if NS<0 then
					tmpHotSpot.Coords=tostring(0-NS).."S, "
				else
					tmpHotSpot.Coords=tostring(NS).."N, "
				end
				if EW<0 then
					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(0-EW).."W"
				else
					tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(EW).."E"
				end
				tmpHotSpot.MouseEnter=function(sender)
					sender.Text:SetBackColor(Turbine.UI.Color(.9,.9,.9))
				end
				tmpHotSpot.MouseLeave=function(sender)
					sender.Text:SetBackColor(Turbine.UI.Color(.6,.7,.8,.8))
				end
				tmpHotSpot.MouseHover=function(sender)
					BDDHotSpotHover(sender)
				end
					table.insert(mapWindow.Map.Overlays[tmpOLIndex].HotSpots,tmpHotSpot)
			end
		end
	end
end